/*
* Licensed Materials - Property of IBM
*
* WebSphere Development Studio Client for i5/OS - WebFacing
*
*  Copyright IBM Corp. 2008 All Rights Reserved
*
* US Government Users Restricted Rights - Use, duplication or
* disclosure restricted by GSA ADP Schedule Contract with
* IBM Corp.
*/
function c_i_e_i_w_7101_JSReorder()               //Visual LTR -> Logical LTR only
{
this.INIT= 0;
this.LATIN= 1;
this.LOCAL= 2;
this.NEUTRAL= 3;
this.LOCALNUMBER= 4;
this.LATINNUMBER= 5;
this.LATINNUMERICTERMINATOR= 6;
this.NUMERICSEPARATOR= 8;
this.ENDOFLINE= 9;
this.CARRIAGERETURN= 10;
this.LINEFEED= 11;
this.SPACE= 12;
this.ARABICDIGIT= 13;
this.SEGMENTSEPARATOR= 14;
this.BLOCKSEPARATOR= 15;
this.BIDISPECIAL= 16;
this.LATIN_STATE= 0;
this.LOCAL_STATE= 1;
this.LATIN_NUM_STATE= 2;
this.LOCAL_NUM_STATE= 3;
this.NEUTRAL_STATE= 4;
this.EOL_STATE= 5;
this.MASK_STATE= 0x00FF;
this.MASK_ACTION= 0xFF00;
this.ACTION= 0x4000;
this.NL= 0x4100;//NEUTRALS TO LATIN
this.NR= 0x4200;//NEUTRALS TO LOCAL
this.LocalInvert= 1;
this.LocalNumInvert= 2;
var NL= this.NL;
var NR= this.NR;
this.StateTable= new Table(6,10);
this.StateTable.initTable(
/*  I   L   R   N   .   D   .   .   E   .*/
/* 0 LATIN_STATE     */ 0,  0,  1,  0,  -1, 2,  -1, -1, 0,  5,
/* 1 LOCAL_STATE     */ 0,  0,  1,  4,  -1, 3,  -1, -1, 4,  5,
/* 2 LATIN_NUM_STATE */ 0,  0,  1,  0,  -1, 2,  -1, -1, 0,  5,
/* 3 LOCAL_NUM_STATE */ 0,  0,  1,  4,  -1, 3,  -1, -1, 4,  5,
/* 4 NEUTRAL_STATE   */ NL|0,   NL|0,   NR|1,   4,  -1, NR|3,   -1, -1, 4,  NL|5,
/* 5 EOL_STATE       */ 0,  0,  1,  0,  -1, 2,  -1, -1, 0,  5
);
this.getStateTable= getStateTable;
this.StateToClass= new Array(this.LATIN, this.LOCAL, this.LATINNUMBER, this.LOCALNUMBER,
this.NEUTRAL, this.ENDOFLINE);
var I     = this.INIT;
var L     = this.LATIN;
var R     = this.LOCAL;
var D     = this.LATINNUMBER;
var X     = this.LATINNUMERICTERMINATOR;
var E     = this.NUMERICSEPARATOR;
var N     = this.NEUTRAL;
var S     = this.SPACE;
var C     = this.CARRIAGERETURN;
var F     = this.LINEFEED;
var A     = this.ARABICDIGIT;
var G     = this.SEGMENTSEPARATOR;
var B     = this.BLOCKSEPARATOR;
var H     = this.BIDISPECIAL;
this.UnicodeTable= new Table(9,256);
this.UnicodeTable.initTable(
/* Table 0: Unicode 00xx */
/************************************************************************/
/*     0   1   2   3   4   5   6   7   8   9   A   B   C   D   E   F    */
/************************************************************************/
/*0-*/ N,  N,  N,  N,  N,  N,  N,  N,  N,  I,  F,  N,  N,  C,  N,  N,
/*1-*/ N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,
/*2-*/ S,  N,  N,  X,  X,  X,  N,  N,  N,  N,  N,  N,  E,  N,  E,  E,
/*3-*/ D,  D,  D,  D,  D,  D,  D,  D,  D,  D,  E,  N,  N,  N,  N,  N,
/*4-*/ N,  L,  L,  L,  L,  L,  L,  L,  L,  L,  L,  L,  L,  L,  L,  L,
/*5-*/ L,  L,  L,  L,  L,  L,  L,  L,  L,  L,  L,  N,  N,  N,  N,  N,
/*6-*/ N,  L,  L,  L,  L,  L,  L,  L,  L,  L,  L,  L,  L,  L,  L,  L,
/*7-*/ L,  L,  L,  L,  L,  L,  L,  L,  L,  L,  L,  N,  N,  N,  N,  N,
/*8-*/ N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,
/*9-*/ N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,
/*A-*/ S,  N,  X,  X,  X,  X,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,
/*B-*/ X,  X,  D,  D,  N,  N,  N,  N,  N,  D,  N,  N,  N,  N,  N,  N,
/*C-*/ L,  L,  L,  L,  L,  L,  L,  L,  L,  L,  L,  L,  L,  L,  L,  L,
/*D-*/ L,  L,  L,  L,  L,  L,  L,  N,  L,  L,  L,  L,  L,  L,  L,  L,
/*E-*/ L,  L,  L,  L,  L,  L,  L,  L,  L,  L,  L,  L,  L,  L,  L,  L,
/*F-*/ L,  L,  L,  L,  L,  L,  L,  N,  L,  L,  L,  L,  L,  L,  L,  L,
/* Table 1: Unicode 05xx */
/************************************************************************/
/*     0   1   2   3   4   5   6   7   8   9   A   B   C   D   E   F    */
/************************************************************************/
/*0-*/ N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,
/*1-*/ N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,
/*2-*/ N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,
/*3-*/ N,  L,  L,  L,  L,  L,  L,  L,  L,  L,  L,  L,  L,  L,  L,  L,
/*4-*/ L,  L,  L,  L,  L,  L,  L,  L,  L,  L,  L,  L,  L,  L,  L,  L,
/*5-*/ L,  L,  L,  L,  L,  L,  L,  N,  N,  L,  L,  L,  L,  L,  L,  L,
/*6-*/ N,  L,  L,  L,  L,  L,  L,  L,  L,  L,  L,  L,  L,  L,  L,  L,
/*7-*/ L,  L,  L,  L,  L,  L,  L,  L,  L,  L,  L,  L,  L,  L,  L,  L,
/*8-*/ L,  L,  L,  L,  L,  L,  L,  L,  N,  L,  N,  N,  N,  N,  N,  N,
/*9-*/ N,  R,  R,  R,  R,  R,  R,  R,  R,  R,  R,  R,  R,  R,  R,  R,
/*A-*/ R,  R,  N,  R,  R,  R,  R,  R,  R,  R,  R,  R,  R,  R,  R,  R,
/*B-*/ R,  R,  R,  R,  R,  R,  R,  R,  R,  R,  N,  R,  R,  R,  R,  R,
/*C-*/ R,  R,  R,  R,  R,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,
/*D-*/ R,  R,  R,  R,  R,  R,  R,  R,  R,  R,  R,  R,  R,  R,  R,  R,
/*E-*/ R,  R,  R,  R,  R,  R,  R,  R,  R,  R,  R,  N,  N,  N,  N,  N,
/*F-*/ R,  R,  R,  R,  R,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,
/* Table 2: Unicode 06xx */
/************************************************************************/
/*     0   1   2   3   4   5   6   7   8   9   A   B   C   D   E   F    */
/************************************************************************/
/*0-*/ N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  R,  N,  N,  N,
/*1-*/ N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  R,  N,  N,  N,  N,
/*2-*/ N,  R,  R,  R,  R,  R,  R,  R,  R,  R,  R,  R,  R,  R,  R,  R,
/*3-*/ R,  R,  R,  R,  R,  R,  R,  R,  R,  R,  R,  N,  N,  N,  N,  N,
/*4-*/ R,  R,  R,  R,  R,  R,  R,  R,  R,  R,  R,  R,  R,  R,  R,  R,
/*5-*/ R,  R,  R,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,
/*6-*/ A,  A,  A,  A,  A,  A,  A,  A,  A,  A,  X,  A,  A,  R,  N,  N,
/*7-*/ R,  R,  R,  R,  R,  R,  R,  R,  R,  R,  R,  R,  R,  R,  R,  R,
/*8-*/ R,  R,  R,  R,  R,  R,  R,  R,  R,  R,  R,  R,  R,  R,  R,  R,
/*9-*/ R,  R,  R,  R,  R,  R,  R,  R,  R,  R,  R,  R,  R,  R,  R,  R,
/*A-*/ R,  R,  R,  R,  R,  R,  R,  R,  R,  R,  R,  R,  R,  R,  R,  R,
/*B-*/ R,  R,  R,  R,  R,  R,  R,  R,  N,  N,  R,  R,  R,  R,  R,  N,
/*C-*/ R,  R,  R,  R,  R,  R,  R,  R,  R,  R,  R,  R,  R,  R,  R,  N,
/*D-*/ R,  R,  R,  R,  R,  R,  R,  R,  R,  R,  R,  R,  R,  R,  R,  R,
/*E-*/ R,  R,  R,  R,  R,  R,  R,  R,  R,  R,  R,  R,  R,  R,  N,  N,
/*F-*/ D,  D,  D,  D,  D,  D,  D,  D,  D,  D,  N,  N,  N,  N,  N,  N,
/* Table 3: Unicode 20xx */
/************************************************************************/
/*     0   1   2   3   4   5   6   7   8   9   A   B   C   D   E   F    */
/************************************************************************/
/*0-*/ S,  S,  S,  S,  S,  S,  S,  E,  S,  S,  S,  S,  N,  N,  L,  R,
/*1-*/ N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,
/*2-*/ N,  N,  N,  N,  N,  N,  N,  N,  B,  B,  H,  N,  N,  N,  H,  N,
/*3-*/ X,  X,  X,  X,  X,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,
/*4-*/ N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,
/*5-*/ N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,
/*6-*/ N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  H,  H,  H,  H,
/*7-*/ D,  N,  N,  N,  D,  D,  D,  D,  D,  D,  X,  X,  N,  N,  N,  N,
/*8-*/ D,  D,  D,  D,  D,  D,  D,  D,  D,  D,  X,  X,  N,  N,  N,  N,
/*9-*/ N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,
/*A-*/ X,  X,  X,  X,  X,  X,  X,  X,  X,  X,  X,  X,  N,  N,  N,  N,
/*B-*/ N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,
/*C-*/ N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,
/*D-*/ L,  L,  L,  L,  L,  L,  L,  L,  L,  L,  L,  L,  L,  L,  L,  L,
/*E-*/ L,  L,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,
/*F-*/ N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,
/* Table 4: Unicode 21xx */
/************************************************************************/
/*     0   1   2   3   4   5   6   7   8   9   A   B   C   D   E   F    */
/************************************************************************/
/*0-*/ N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,
/*1-*/ N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,
/*2-*/ N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,
/*3-*/ N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,
/*4-*/ N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,
/*5-*/ N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,
/*6-*/ L,  L,  L,  L,  L,  L,  L,  L,  L,  L,  L,  L,  L,  L,  L,  L,
/*7-*/ L,  L,  L,  L,  L,  L,  L,  L,  L,  L,  L,  L,  L,  L,  L,  L,
/*8-*/ L,  L,  L,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,
/*9-*/ N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,
/*A-*/ N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,
/*B-*/ N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,
/*C-*/ N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,
/*D-*/ N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,
/*E-*/ N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,
/*F-*/ N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,
/* Table 5: Unicode 30xx */
/************************************************************************/
/*     0   1   2   3   4   5   6   7   8   9   A   B   C   D   E   F    */
/************************************************************************/
/*0-*/ S,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,
/*1-*/ N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,
/*2-*/ N,  L,  L,  L,  L,  L,  L,  L,  L,  L,  L,  L,  L,  L,  L,  L,
/*3-*/ N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,
/*4-*/ N,  L,  L,  L,  L,  L,  L,  L,  L,  L,  L,  L,  L,  L,  L,  L,
/*5-*/ L,  L,  L,  L,  L,  L,  L,  L,  L,  L,  L,  L,  L,  L,  L,  L,
/*6-*/ L,  L,  L,  L,  L,  L,  L,  L,  L,  L,  L,  L,  L,  L,  L,  L,
/*7-*/ L,  L,  L,  L,  L,  L,  L,  L,  L,  L,  L,  L,  L,  L,  L,  L,
/*8-*/ L,  L,  L,  L,  L,  L,  L,  L,  L,  L,  L,  L,  L,  L,  L,  L,
/*9-*/ L,  L,  L,  L,  L,  N,  N,  N,  N,  L,  L,  L,  L,  L,  L,  N,
/*A-*/ N,  L,  L,  L,  L,  L,  L,  L,  L,  L,  L,  L,  L,  L,  L,  L,
/*B-*/ L,  L,  L,  L,  L,  L,  L,  L,  L,  L,  L,  L,  L,  L,  L,  L,
/*C-*/ L,  L,  L,  L,  L,  L,  L,  L,  L,  L,  L,  L,  L,  L,  L,  L,
/*D-*/ L,  L,  L,  L,  L,  L,  L,  L,  L,  L,  L,  L,  L,  L,  L,  L,
/*E-*/ L,  L,  L,  L,  L,  L,  L,  L,  L,  L,  L,  L,  L,  L,  L,  L,
/*F-*/ L,  L,  L,  L,  L,  L,  L,  L,  L,  L,  L,  L,  L,  L,  L,  N,
/* Table 6: Unicode FBxx */
/************************************************************************/
/*     0   1   2   3   4   5   6   7   8   9   A   B   C   D   E   F    */
/************************************************************************/
/*0-*/ L,  L,  L,  L,  L,  L,  L,  N,  N,  N,  N,  N,  N,  N,  N,  N,
/*1-*/ N,  N,  N,  L,  L,  L,  L,  L,  N,  N,  N,  N,  N,  N,  R,  R,
/*2-*/ R,  R,  R,  R,  R,  R,  R,  R,  R,  R,  R,  R,  R,  R,  R,  R,
/*3-*/ R,  R,  R,  R,  R,  R,  R,  N,  R,  R,  R,  R,  R,  N,  R,  N,
/*4-*/ R,  R,  N,  R,  R,  N,  R,  R,  R,  R,  R,  R,  R,  R,  R,  R,
/*5-*/ R,  R,  R,  R,  R,  R,  R,  R,  R,  R,  R,  R,  R,  R,  R,  R,
/*6-*/ R,  R,  R,  R,  R,  R,  R,  R,  R,  R,  R,  R,  R,  R,  R,  R,
/*7-*/ R,  R,  R,  R,  R,  R,  R,  R,  R,  R,  R,  R,  R,  R,  R,  R,
/*8-*/ R,  R,  R,  R,  R,  R,  R,  R,  R,  R,  R,  R,  R,  R,  R,  R,
/*9-*/ R,  R,  R,  R,  R,  R,  R,  R,  R,  R,  R,  R,  R,  R,  R,  R,
/*A-*/ R,  R,  R,  R,  R,  R,  R,  R,  R,  R,  R,  R,  R,  R,  R,  R,
/*B-*/ R,  R,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,
/*C-*/ N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,
/*D-*/ N,  N,  N,  R,  R,  R,  R,  R,  R,  R,  R,  R,  R,  R,  R,  R,
/*E-*/ R,  R,  R,  R,  R,  R,  R,  R,  R,  R,  R,  R,  R,  R,  R,  R,
/*F-*/ R,  R,  R,  R,  R,  R,  R,  R,  R,  R,  R,  R,  R,  R,  R,  R,
/* Table 7: Unicode FExx */
/************************************************************************/
/*     0   1   2   3   4   5   6   7   8   9   A   B   C   D   E   F    */
/************************************************************************/
/*0-*/ N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,
/*1-*/ N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,
/*2-*/ N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,
/*3-*/ N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,
/*4-*/ N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,
/*5-*/ N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,
/*6-*/ N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,
/*7-*/ R,  R,  R,  N,  R,  N,  R,  R,  R,  R,  R,  R,  R,  R,  R,  R,
/*8-*/ R,  R,  R,  R,  R,  R,  R,  R,  R,  R,  R,  R,  R,  R,  R,  R,
/*9-*/ R,  R,  R,  R,  R,  R,  R,  R,  R,  R,  R,  R,  R,  R,  R,  R,
/*A-*/ R,  R,  R,  R,  R,  R,  R,  R,  R,  R,  R,  R,  R,  R,  R,  R,
/*B-*/ R,  R,  R,  R,  R,  R,  R,  R,  R,  R,  R,  R,  R,  R,  R,  R,
/*C-*/ R,  R,  R,  R,  R,  R,  R,  R,  R,  R,  R,  R,  R,  R,  R,  R,
/*D-*/ R,  R,  R,  R,  R,  R,  R,  R,  R,  R,  R,  R,  R,  R,  R,  R,
/*E-*/ R,  R,  R,  R,  R,  R,  R,  R,  R,  R,  R,  R,  R,  R,  R,  R,
/*F-*/ R,  R,  R,  R,  R,  R,  R,  R,  R,  R,  R,  R,  R,  N,  N,  N,
/* Table 8: Unicode FFxx */
/************************************************************************/
/*     0   1   2   3   4   5   6   7   8   9   A   B   C   D   E   F    */
/************************************************************************/
/*0-*/ N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,
/*1-*/ D,  D,  D,  D,  D,  D,  D,  D,  D,  D,  N,  N,  N,  N,  N,  N,
/*2-*/ N,  L,  L,  L,  L,  L,  L,  L,  L,  L,  L,  L,  L,  L,  L,  L,
/*3-*/ L,  L,  L,  L,  L,  L,  L,  L,  L,  L,  L,  N,  N,  N,  N,  N,
/*4-*/ N,  L,  L,  L,  L,  L,  L,  L,  L,  L,  L,  L,  L,  L,  L,  L,
/*5-*/ L,  L,  L,  L,  L,  L,  L,  L,  L,  L,  L,  N,  N,  N,  N,  N,
/*6-*/ N,  N,  N,  N,  N,  L,  L,  L,  L,  L,  L,  L,  L,  L,  L,  L,
/*7-*/ L,  L,  L,  L,  L,  L,  L,  L,  L,  L,  L,  L,  L,  L,  L,  L,
/*8-*/ L,  L,  L,  L,  L,  L,  L,  L,  L,  L,  L,  L,  L,  L,  L,  L,
/*9-*/ L,  L,  L,  L,  L,  L,  L,  L,  L,  L,  L,  L,  L,  L,  L,  L,
/*A-*/ L,  L,  L,  L,  L,  L,  L,  L,  L,  L,  L,  L,  L,  L,  L,  L,
/*B-*/ L,  L,  L,  L,  L,  L,  L,  L,  L,  L,  L,  L,  L,  L,  L,  N,
/*C-*/ N,  N,  L,  L,  L,  L,  L,  L,  N,  N,  L,  L,  L,  L,  L,  L,
/*D-*/ N,  N,  L,  L,  L,  L,  L,  L,  N,  N,  L,  L,  L,  N,  N,  N,
/*E-*/ N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,
/*F-*/ N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N,  N
);
this.getUnicodeTable= getUnicodeTable;
this.stringAsClasses= new Array();
this.terminatorFlag= 0;
this.doReorder= doReorder;
this.stringToClass= stringToClass;
this.applyClass= applyClass;
this.getCharClass= getCharClass;
this.getCharacterType= getCharacterType;
this.doAction= doAction;
this.invertSegment= invertSegment;
this.needInvert= needInvert;
this.doSymSwap= doSymSwap;
}
function doSymSwap(symbol) {
switch(symbol)
{
case "(":
symbol= ")";
break;
case ")":
symbol= "(";
break;
case "{":
symbol= "}";
break;
case "}":
symbol= "{";
break;
case "[":
symbol= "]";
break;
case "]":
symbol= "[";
break;
case "<":
symbol= ">";
break;
case ">":
symbol= "<";
break;
}
return symbol;
}
function getStateTable()
{
return this.StateTable;
}
function getUnicodeTable()
{
return this.UnicodeTable;
}
function getCharacterType(ch)
{
var utab= this.getUnicodeTable().getArray();
var str= new String(ch);
var code= str.charCodeAt(0);
var index= (code & 0xFF00) >> 8;
switch (index)
{
case 0x00: break;
case 0x05: index= 1;
break;
case 0x06: index= 2;
break;
case 0x20: index= 3;
break;
case 0x21: index= 4;
break;
case 0x30: index= 5;
break;
case 0xFB: index= 6;
break;
case 0xFE: index= 7;
break;
case 0xFF: index= 8;
break;
default:   return(this.NEUTRAL);
}
return (utab[index][code & 0xFF]);
}
function doReorder(str)
{
if (str== null || str.length < 2){
return (str);}
this.stringToClass(str);
return (this.applyClass(str));
}
function stringToClass(str)
{
var stab= this.getStateTable().getArray();
var prevState= 0;
var initialCharClass= this.LATIN;
var curState= stab[prevState][initialCharClass];
var curCharClass;
var i;
for (i=0;i<str.length;i++)
{
prevState= curState;
curCharClass= this.getCharClass(str,i);
curState= stab[prevState][curCharClass];
this.stringAsClasses[i]= this.StateToClass[curState & this.MASK_STATE] | this.terminatorFlag;
this.doAction(curState,i);
curState &= this.MASK_STATE;
}
for (i=0;i<str.length;i++){
if ((this.stringAsClasses[i] & this.MASK_ACTION)== this.ACTION){
this.stringAsClasses[i] &= this.MASK_STATE;}
}
}
function getCharClass(str,index)
{
var prev= this.NEUTRAL;
var next= this.NEUTRAL;
var curr;
var result;
this.terminatorFlag= 0
if (index > 0)
prev= this.getCharacterType(str.charAt(index-1));
curr= this.getCharacterType(str.charAt(index));
switch (curr)
{
case this.BLOCKSEPARATOR:
case this.SEGMENTSEPARATOR:
result= this.LATIN;
break;
case this.ARABICDIGIT:
result= this.LATINNUMBER;
break;
case this.LATINNUMERICTERMINATOR:
if (index>0)
prev= this.stringAsClasses[index-1];
if (prev== this.LATINNUMBER || prev== this.LOCALNUMBER){
result= this.LATINNUMBER;}
else
{
this.terminatorFlag= this.ACTION;
result= this.NEUTRAL;
}
break;
case this.NUMERICSEPARATOR:
result= this.NEUTRAL;
if (prev== this.LATINNUMBER)
{
if (index < str.length - 1){
next= this.getCharacterType(str.charAt(index+1));}
switch (next)
{
case this.LATINNUMBER:
result= next;
break;
case this.LOCAL:
case this.NEUTRAL:
result= curr;
break;
}
}
break;
case this.BIDISPECIAL:
case this.SPACE:
result= this.NEUTRAL;
break;
case this.CARRIAGERETURN:
case this.LINEFEED:
result= this.ENDOFLINE;
break;
default:
result= curr;
}
return (result);
}
function doAction(currState,index)
{
var action= currState & this.MASK_ACTION;
var classFromAction;
switch (action)
{
case this.NL:
case this.NR:
classFromAction= (action & this.MASK_ACTION & ~this.ACTION) >> 8;
while (index-- > 0)
{
if ((this.stringAsClasses[index] & this.MASK_STATE)== this.NEUTRAL)
{
if ((this.stringAsClasses[index] & this.MASK_ACTION) &&
(this.stringAsClasses[index+1]== this.LOCALNUMBER ||
this.stringAsClasses[index+1]== this.LATINNUMBER)){
this.stringAsClasses[index]= this.stringAsClasses[index+1];}
else {
this.stringAsClasses[index]= classFromAction;}
}
else
break;
}
break;
}
}
function applyClass(str)
{
var array= new Array(str.length);
var Str= new String("");
var i;
for (i=0;i<str.length;i++){
array[i]= str.charAt(i);}
this.invertSegment(array,this.LocalNumInvert);
this.invertSegment(array,this.LocalInvert);
for (i=0;i<array.length;i++){
Str += array[i];}
return (Str);
}
function needInvert(invertType,index)
{
switch (invertType)
{
case this.LocalInvert:
return (this.stringAsClasses[index]== this.LOCAL ||
this.stringAsClasses[index]== this.LOCALNUMBER);
case this.LocalNumInvert:
return (this.stringAsClasses[index]== this.LOCALNUMBER);
default:
return (false);
}
}
function invertSegment(s,invertType)
{
var start= 0;
var end;
var sum;
var tmp;
var i;
while (start < s.length)
{
if (this.needInvert(invertType,start))
{
end= start + 1;
while (end < s.length)
{
if (!this.needInvert(invertType,end)) {
break;}
end++;
}
sum= end - 1 + start;
for (;start < sum - start;start++)
{
tmp= this.doSymSwap(s[start])
s[start]= this.doSymSwap(s[sum-start])
s[sum-start]= tmp
}
start= end - 1;
}
start++;
}
}
function Table(nrows,ncols)
{
var i= 0;
this.trows= nrows;
this.tcols= ncols;
this.rows= new Array(nrows);
for (i=0;i<nrows;i++){
this.rows[i]= new Array(ncols);}
this.initTable= initTable;
this.getArray= getArray;
}
function getArray()
{
return this.rows;
}
function initTable()
{
var i= 0;
var j= 0;
var k= 0;
var l= 0;
var m= Math.min(this.trows*this.tcols,initTable.arguments.length);
for (k=0;k<m;k++,l++)
{
if (l== this.tcols)
{
i++;
j=0;
l=0;
}
this.rows[i][j++]= this.initTable.arguments[k];
}
}
/*
* Licensed Materials - Property of IBM
*
* WebSphere Development Studio Client for i5/OS - WebFacing
*
*  Copyright IBM Corp. 2008 All Rights Reserved
*
* US Government Users Restricted Rights - Use, duplication or
* disclosure restricted by GSA ADP Schedule Contract with
* IBM Corp.
*/
function c_i_e_i_w_7101_JSReorderSmartlogical(){
var LRO= '\u202D';// String.fromCharCode(8237)
var RLO= '\u202E';
var PDF= '\u202C';
var LRE= '\u202A';
var RLE= '\u202B';
var LRM= '\u200E';
var RLM= '\u200F';
var DIRECTIONALITY_LEFT_TO_RIGHT= 0;
var DIRECTIONALITY_RIGHT_TO_LEFT= 1;
var DIRECTIONALITY_RIGHT_TO_LEFT_ARABIC= 2;
var DIRECTIONALITY_EUROPEAN_NUMBER= 3;
var DIRECTIONALITY_NEUTRAL    = 4;
this.transformSLToVisual= transformSLToVisual
this.transformVisualToSL= transformVisualToSL
this.stripSpecialCharacters= stripSpecialCharacters
this.getDirectionality= getDirectionality
this.parseRoundTrip= parseRoundTrip
this.preventRoundTrip= preventRoundTrip
function transformSLToVisual(text){
var jr= new c_i_e_i_w_7101_JSReorder();
resultText= jr.doReorder(text);
resultText= stripSpecialCharacters(resultText);
return resultText;
}
function transformVisualToSL(text){
var jr= new c_i_e_i_w_7101_JSReorder();// c_i_e_i_w_7101_JSReorder();
resultText= text;
resultText= preventRoundTrip(resultText);
resultText= jr.doReorder(resultText);
return resultText;
}
function stripSpecialCharacters(str) {
if((str== null) || (str.length== 0))
return str;
var buf= "";
var character;
var i;
for(i= 0;i < str.length;i++){
character= str.charAt(i);
if((character != LRE) && (character != RLE)
&& (character != LRM) && (character != RLM)
&& (character != LRO) && (character != RLO) &&
(character != PDF)) {
buf+=character;
}
}
return buf;
}
function getDirectionality(c){
if(c > '\u00ff')
return DIRECTIONALITY_RIGHT_TO_LEFT;
else if (c >= '\u0030' && c <= '\u0039')
return DIRECTIONALITY_EUROPEAN_NUMBER;
else if ((c >= '\u0041' && c <= '\u005A') || (c >= '\u0061' && c <= '\u007A'))
return DIRECTIONALITY_LEFT_TO_RIGHT;
else return DIRECTIONALITY_NEUTRAL;
}
function  parseRoundTrip(str){
bidiSegmentsPointers= new Array();
var sp_len= 0;
var index= 0,
isNational= -1;
for (i= 0;i < str.length;i++) {
dir= getDirectionality(str.charAt(i));
if ((isNational== -1) && (dir== DIRECTIONALITY_RIGHT_TO_LEFT))
isNational= 0;
else if (isNational != -1) {
if (dir== DIRECTIONALITY_LEFT_TO_RIGHT)
isNational= -1;
else if ((isNational== 0) && (dir== DIRECTIONALITY_EUROPEAN_NUMBER)) {
bidiSegmentsPointers.splice(index, 0, i);//?add (index, i);
index++;
isNational= i;
} else if ((isNational > 1) && (dir== DIRECTIONALITY_RIGHT_TO_LEFT)) {
index--;
isNational= 0;
}
}
}
return bidiSegmentsPointers;
}
function  parseWinCompat(str,bidiSegmentsPointers){//67755
var sp_len= 0;
var index= bidiSegmentsPointers.length;
var isDigit= false;
for (i= 0;i < str.length;i++) {
dir= getDirectionality(str.charAt(i));
if (dir== DIRECTIONALITY_EUROPEAN_NUMBER)
isDigit= true;
else if (isDigit) {
if (dir== DIRECTIONALITY_RIGHT_TO_LEFT) {
bidiSegmentsPointers.splice(index, 0, i);
index++;
}
isDigit= false;
}
}
return bidiSegmentsPointers;
}
function preventRoundTrip(str) {
str= stripSpecialCharacters(str);
bidiSegmentsPointers= parseRoundTrip(str);
bidiSegmentsPointers= parseWinCompat(str,bidiSegmentsPointers);//67755
var buf= str;
shift= 0;
var n;
for (i= bidiSegmentsPointers.length - 1;i >= 0;i--) {//67755
n= bidiSegmentsPointers[i];
if(n != null){
preStr= buf.substring(0, n + shift);
postStr= buf.substring(n + shift, buf.length);
buf= preStr + LRM + postStr;
shift++;
}
}
return buf;
}
}
/*
* Licensed Materials - Property of IBM
*
* WebSphere Development Studio Client for i5/OS - WebFacing
*
* bidishape.js
*
*  Copyright IBM Corp. 2008 All Rights Reserved
*
* US Government Users Restricted Rights - Use, duplication or
* disclosure restricted by GSA ADP Schedule Contract with
* IBM Corp.
*/
function c_i_e_i_w_7101_JSShapingEngine()
{
var INIT            = 0x80000000;
var LEVEL           = 0x70000000;
var TEXTTYPE        = 0x01000000;
var TEXT_ORIENTATION= 0x00030000;
var NUMERALS        = 0x00003000;
var SYM_SWAP        = 0x00000100;
var WORD_BREAK      = 0x00000200;
var TEXT_SHAPE      = 0x000000FF;
var ROUND_TRIP      = 0X00100000;
var TEXT_VISUAL     = 0x00000000;
var TEXT_IMPLICIT   = 0x01000000;
var ORIENTATION_LTR = 0x00000000;
var ORIENTATION_RTL = 0x00010000;
var ORIENTATION_CONTEXT_LTR= 0x00020000;
var ORIENTATION_CONTEXT_RTL= 0x00030000;
var NUMERALS_NOMINAL= 0x00000000;
var NUMERALS_NATIONAL= 0x00002000;
var NUMERALS_CONTEXTUAL= 0x00003000;
var BREAK           = 0x00000200;
var NO_BREAK        = 0x00000000;
var SWAPPING        = 0x00000100;
var NO_SWAPPING     = 0x00000000;
var TEXT_SHAPED     = 0x00000000;
var TEXT_NOMINAL    = 0x00000010;
var TEXT_INITIAL    = 0x00000011;
var TEXT_MIDDLE     = 0x00000012;
var TEXT_FINAL      = 0x00000013;
var TEXT_ISOLATED   = 0x00000014;
var TAIL            = 0xFE73;//@bd1c_ramysaid
var ROUND_TRIP_ON   = 0x00000000;
var ROUND_TRIP_OFF  = 0x00100000;
var formatedAttributes= 0;
this.ara_type_shape_all= ara_type_shape_all;//bidi1
this.ara_type= ara_type;//bidi1
this.deshape=deshape;//@bd2a_ramysaid
this.getLamAlefsCountIn06Buffer=getLamAlefsCountIn06Buffer;
this.getLamAlefsCountInBufferRange=getLamAlefsCountInBufferRange;
this.getLamAlefsCountInFEBuffer=getLamAlefsCountInFEBuffer;
this.getAllFEshapesForChar=getAllFEshapesForChar;
function setAttribute (name ,value){
formatedAttributes= ((formatedAttributes & (~(name))) | (value & (name)));
}
function getAttribute (attr ,name){
return ((attr) & (name));
}
var LINKR= 1;
var LINKL= 2;
var IRRELEVANT= 4;
var LAMTYPE= 16;
var ALEFTYPE= 32;
var LINKFIELD= 3;
var lamAlphCount= 0;
var shapeTable=     [
[ [0,0,0,0],   [0,0,0,0],     [0,1,0,3],     [0,1,0,1] ],
[ [0,0,2,2],   [0,0,1,2],     [0,1,1,2],     [0,1,1,3] ],
[ [0,0,0,0],   [0,0,0,0],     [0,1,0,3],     [0,1,0,3] ],
[ [0,0,1,2],   [0,0,1,2],     [0,1,1,2],     [0,1,1,3] ]
];
var convertFEto06=     [
0x64B, 0x64B,
0x64C, 0x64C,
0x64D, 0x64D,
0x64E, 0x64E,
0x64F, 0x64F,
0x650, 0x650,
0x651, 0x651,
0x652, 0x652,
0x621,
0x622, 0x622,
0x623,0x623,
0x624,0x624,
0x625,0x625,
0x626,0x626,0x626,0x626,
0x627,0x627,
0x628,0x628,0x628,0x628,
0x629,0x629,
0x62A,0x62A,0x62A,0x62A,
0x62B,0x62B,0x62B,0x62B,
0x62C,0x62C,0x62C,0x62C,
0x62D,0x62D,0x62D,0x62D,
0x62E,0x62E,0x62E,0x62E,
0x62F,0x62F,
0x630,0x630,
0x631,0x631,
0x632,0x632,
0x633,0x633, 0x633,0x633,
0x634, 0x634,0x634,0x634,
0x635,0x635,0x635,0x635,
0x636,0x636,0x636,0x636,
0x637,0x637,0x637,0x637,
0x638,0x638,0x638,0x638,
0x639,0x639,0x639,0x639,
0x63A,0x63A,0x63A,0x63A,
0x641,0x641,0x641,0x641,
0x642,0x642,0x642,0x642,
0x643,0x643,0x643,0x643,
0x644,0x644,0x644,0x644,
0x645,0x645,0x645,0x645,
0x646,0x646,0x646,0x646,
0x647,0x647,0x647,0x647,
0x648, 0x648,
0x649,0x649,
0x64A,0x64A,0x64A,0x64A,
0x65C, 0x65C,
0x65D,0x65D,
0x65E,0x65E,
0x65F,0x65F
];
var Link06= [
1           + 32 + 256 * 0x11,
1           + 32 + 256 * 0x13,
1                + 256 * 0x15,
1           + 32 + 256 * 0x17,
1 + 2            + 256 * 0x19,
1           + 32 + 256 * 0x1D,
1 + 2            + 256 * 0x1F,
1                + 256 * 0x23,
1 + 2            + 256 * 0x25,
1 + 2            + 256 * 0x29,
1 + 2            + 256 * 0x2D,
1 + 2            + 256 * 0x31,
1 + 2            + 256 * 0x35,
1                + 256 * 0x39,
1                + 256 * 0x3B,
1                + 256 * 0x3D,
1                + 256 * 0x3F,
1 + 2            + 256 * 0x41,
1 + 2            + 256 * 0x45,
1 + 2            + 256 * 0x49,
1 + 2            + 256 * 0x4D,
1 + 2            + 256 * 0x51,
1 + 2            + 256 * 0x55,
1 + 2            + 256 * 0x59,
1 + 2            + 256 * 0x5D,
0, 0, 0, 0, 0, /* 0x63B - 0x63F */
1 + 2,
1 + 2            + 256 * 0x61,
1 + 2            + 256 * 0x65,
1 + 2            + 256 * 0x69,
1 + 2       + 16 + 256 * 0x6D,
1 + 2            + 256 * 0x71,
1 + 2            + 256 * 0x75,
1 + 2            + 256 * 0x79,
1                + 256 * 0x7D,
1                + 256 * 0x7F,
1 + 2            + 256 * 0x81,
4, 4, 4, 4,
4, 4, 4, 4,      /* 0x64B - 0x652 */
0, 0, 0, 0, 0,
0, 0, 0, 0,      /* 0x653 - 0x65B */
1                + 256 * 0x85,
1                + 256 * 0x87,
1                + 256 * 0x89,
1                + 256 * 0x8B,
0, 0, 0, 0, 0,
0, 0, 0, 0, 0,
0, 0, 0, 0, 0, 0, /* 0x660 - 0x66F */
4,
0,
1           + 32,
1           + 32,
0,
1           + 32,
1, 1,
1+2, 1+2, 1+2, 1+2, 1+2, 1+2,
1+2, 1+2, 1+2, 1+2, 1+2, 1+2,
1+2, 1+2, 1+2, 1+2,
1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
1, 1, 1, 1, 1, 1, 1, 1,
1+2, 1+2, 1+2, 1+2, 1+2, 1+2, 1+2, 1+2, 1+2, 1+2,
1+2, 1+2, 1+2, 1+2, 1+2, 1+2, 1+2, 1+2, 1+2, 1+2,
1+2, 1+2, 1+2, 1+2, 1+2, 1+2, 1+2, 1+2, 1+2, 1+2,
1+2, 1+2, 1+2, 1+2, 1+2, 1+2, 1+2, 1+2,
1,
1+2,
1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
1+2,
1,
1+2, 1+2, 1+2, 1+2,
1, 1
];
var LinkFE=[
1 + 2,
1 + 2,
1 + 2, 0, 1+ 2, 0, 1+ 2,
1 + 2,
1+ 2, 1 + 2, 1+2, 1 + 2,
1+ 2, 1 + 2, 1+2, 1 + 2,
0, 0 + 32, 1 + 32, 0 + 32,
1 + 32, 0, 1,  0 + 32,
1 + 32, 0, 2,  1 + 2,
1, 0 + 32, 1 + 32, 0,
2, 1 + 2, 1, 0,
1, 0, 2, 1 + 2,
1, 0, 2, 1 + 2,
1, 0, 2, 1 + 2,
1, 0, 2, 1 + 2,
1, 0, 2, 1 + 2,
1, 0, 1, 0,
1, 0, 1, 0,
1, 0, 2, 1+2,
1, 0, 2, 1+2,
1, 0, 2, 1+2,
1, 0, 2, 1+2,
1, 0, 2, 1+2,
1, 0, 2, 1+2,
1, 0, 2, 1+2,
1, 0, 2, 1+2,
1, 0, 2, 1+2,
1, 0, 2, 1+2,
1, 0, 2, 1+2,
1, 0 + 16, 2 + 16, 1 + 2 +16,
1 + 16, 0, 2, 1+2,
1, 0, 2, 1+2,
1, 0, 2, 1+2,
1, 0, 1, 0,
1, 0, 2, 1+2,
1, 0, 1, 0,
1, 0, 1, 0,
1
];
var IrreleventPos=          [
0x0,
0x2,
0x4,
0x6,
0x8,
0xA,
0xC,
0xE,
];
var AlefTable=             [
0x0622,
0x0623,
0x0625,
0x0627
];
var LamAlefTable=          [
0xfef5,
0xfef7,
0xfef9,
0xfefb
];
var AlefTableFE=          [
0xFE81,
0xFE82,
0xFE83,
0xFE84,
0xFE87,
0xFE88,
0xFE8D,
0xFE8E
];
var LamTableFE=            [
0xFEDD,
0xFEDE,
0xFEDF,
0xFEE0
];
var  LamAlefTableFE=       [
0xfef5,
0xfef7,
0xfef9,
0xfefb,
0xfef6,
0xfef8,
0xfefa,
0xfefc
];
function uba_getLink(x){
if(x >= 0x0622 && x <= 0x06D3)
return(Link06[x-0x0622]);
else if(x== 0x200D)
return(3);
else if(x >= 0x206D && x <= 0x206F)
return(4);
else if(x >= 0xFE70 && x <= 0xFEFC)
return(LinkFE[x-0xFE70]);
else
return(0);
}
function LamAlef(alef){
for(var i=0;i<AlefTable.length;i++){
if(AlefTable[i]==alef)
return LamAlefTable[i];
}
return 0;
}
function isAlef(c){
for(var i=0;i<AlefTable.length;i++){
if(AlefTable[i]==c) return true;
}
return false;
}
function isAlefFE(c){
for(var i=0;i<AlefTableFE.length;i++){
if(AlefTableFE[i]==c) return true;
}
return false;
}
function isLamFE(c){
for(var i=0;i<LamTableFE.length;i++){
if(LamTableFE[i]==c) return true;
}
return false;
}
function isLamAlefFE(c){
for(var i=0;i<LamAlefTableFE.length;i++){
if(LamAlefTableFE[i]==c) return true;
}
return false;
}
function LamAlefFE(alef){
for(var i=0;i<AlefTableFE.length;i++){
if(AlefTableFE[i]==alef)
return LamAlefTableFE[i/2];
}
return 0;
}
function specialChar(ch){
if((ch >= 0x0621 && ch < 0x0626)|| (ch== 0x0627)||
(ch > 0x062e && ch < 0x0633) ||
(ch > 0x0647 && ch < 0x064a) || (ch== 0x0629)
||  (ch >= 0x065C && ch <= 0x065F))
return(1);
else
return(0);
}
function YeehHamzaChar(ch){
if ((ch==0xFE89) ||  (ch==0xFE8A))
return(true);
else
return(false);
}
function Lamalef(x){
if(x== 0x0622)
return(0x065C);
else if(x== 0x0623)
return(0x065D);
else if(x== 0x0625)
return(0x065E);
else if(x== 0x0627)
return(0x065F);
else
return(0);
}
function SeenChar(ch){
if ((ch==0xFEB1) || (ch==0xFEB2) ||
(ch==0xFEB5) || (ch==0xFEB6) ||
(ch==0xFEB9) || (ch==0xFEBA) ||
(ch==0xFEBD) || (ch==0xFEBE))
return(true);
else
return(false);
}
function CompressLamAlef(UniBuff,length,bRev){
var  CompressedArray= new Array(length);
var i=0;
var j=0;
var Lam= 0x0644;
for(i=0;i < length - 1;i++){
if((bRev && isAlef(UniBuff[i]) && UniBuff[i+1]==Lam)||(!bRev && isAlef(UniBuff[i+1]) && UniBuff[i]==Lam)){
CompressedArray[j++]=LamAlef((bRev)?UniBuff[i]:UniBuff[i+1]);
i++;
}else
CompressedArray[j++]=UniBuff[i];
}
if(i<length)
CompressedArray[j++]=UniBuff[i];
return CompressedArray;
}
/*function shape (TXT_ORIENTATION_RTL,INPUT_BUFF) {
c_i_e_i_w_7101_shape (TXT_ORIENTATION_RTL,INPUT_BUFF,true)
}*/
function shape (TXT_ORIENTATION_RTL,INPUT_BUFF,expand_seen_yeh) {
var currLink;
var lastLink=0;
var nextLink=0;
var prevLink=0;
var lastPos;
var Nx;
var prevPos;
var iEnd, Nw, step,  Shape, i, Ix;
var wLamalef;
var wBuf;
var j,x;
var flag;
var trgIdx= 0;
var RTL= true;
var inOutDiff= false;
var size;
if (INPUT_BUFF.length== 0)
return;
var str06= new Array(INPUT_BUFF.length);
str06= INPUT_BUFF;
if(TXT_ORIENTATION_RTL)
RTL= true;
else
RTL= false
inOutDiff= true;
for (var idx= 0;idx < str06.length;idx++){
var inputChar= str06[idx];
if ((inputChar >= 0xFE70) && (inputChar <= 0xFEFC)){
str06[trgIdx]= convertFEto06 [(inputChar - 0xFE70) ];
}else{
str06[trgIdx]= inputChar;
}
trgIdx++;
}
if (RTL && inOutDiff){
Ix= 0;
iEnd= str06.length;
step= +1;
}
else {
Ix= str06.length - 1;
iEnd= -1;
step= -1;
}
size= str06.length;
prevLink= 0;
lastLink= 0;
currLink= uba_getLink (str06[Ix]);
prevPos= Ix;
lastPos= Ix;
Nx= -2;
while (Ix != iEnd) {
if ((currLink & 0xFF00) > 0) {
Nw= Ix + step;
while (Nx < 0) {
if (Nw== iEnd) {
nextLink= 0;
Nx= 30000;
}
else {
nextLink= uba_getLink(str06[Nw]);
if ((nextLink & IRRELEVANT)== 0)
Nx= Nw;
else Nw += step;
}
}
if (((currLink & ALEFTYPE) > 0)  &&  ((lastLink & LAMTYPE) > 0))
{
wLamalef= Lamalef(str06[Ix]);
if (wLamalef != 0)
{
if (RTL && inOutDiff)
{
str06[lastPos]= wLamalef;
str06[Ix]=  0x0020;
Ix=lastPos;
}
else {
str06[Ix]= 0x0020;
str06[lastPos]= wLamalef;
Ix=lastPos;
}
}
lastLink= prevLink;
currLink= uba_getLink(wLamalef);
}
flag=specialChar (str06[Ix]);
if (getAttribute(formatedAttributes, TEXT_SHAPE)== TEXT_INITIAL)
{
if(flag==0)
Shape= 2;
else
Shape= 0;
}
else
if (getAttribute(formatedAttributes,TEXT_SHAPE)== TEXT_MIDDLE)
{
if(flag== 0)
Shape= 3;
else
Shape= 1;
}
else
if (getAttribute(formatedAttributes,TEXT_SHAPE)== TEXT_FINAL)
{
if(flag== 0)
Shape= 1;
else
Shape= 1;
}
else
if (getAttribute(formatedAttributes, TEXT_SHAPE)== TEXT_ISOLATED)
{
Shape= 0;
}
else{
Shape= shapeTable[nextLink & (LINKR + LINKL)]
[lastLink & (LINKR + LINKL)]
[currLink & (LINKR + LINKL)];
}
str06[Ix]=  (0xFE70 + (currLink >> 8) + Shape);
}
if ((currLink & IRRELEVANT)== 0) {
prevLink= lastLink;
lastLink= currLink;
prevPos= lastPos;
lastPos= Ix;
}
if ((currLink & IRRELEVANT) > 0) {
var charidx= str06[Ix] - 0x064B;
var  MyShape=0;
var next=  (nextLink & (LINKR + LINKL));
var last=lastLink & (LINKR + LINKL);
if  (((last==3)&& (next==1))
|| ((last==3) && (next==3)))
MyShape= 1;
if (((nextLink & ALEFTYPE) > 0)  &&  ((lastLink & LAMTYPE) > 0))
MyShape=0;
if ((str06[Ix]==0x064C)  || (str06[Ix]==0x064D))
MyShape=0;
str06[Ix]=  (0xFE70 + IrreleventPos[charidx]+ MyShape);
}
Ix += step;
if (Ix== Nx) {
currLink= nextLink;
Nx= -2;
}
else            {
if (Ix != iEnd)
currLink= uba_getLink (str06[Ix]);
}
}
if(expand_seen_yeh)
for (var idx= 0;idx < str06.length;idx++)
{
if (RTL && inOutDiff)
{
if ((SeenChar(str06[idx]))  && ((idx+1 < str06.length)
&& (str06[idx+1]== 0x0020)))
str06[idx+1]= TAIL;
if ((!SeenChar(str06[idx]))
&& ((idx+1 < str06.length) && (str06[idx+1]== TAIL)))
str06[idx+1]= 0x0020;
if  (YeehHamzaChar(str06[idx]))
if ((idx+1 < str06.length) && (str06[idx+1]== 0x0020))
{
if(str06[idx]== 0xFE89)
str06[idx]=  0xFEEF;
else
str06[idx]=  0xFEF0;
str06[idx+1]=  0xFE80;
}
else
{
if(str06[idx]== 0xFE89)
str06[idx]=  0xFE8B;
else
str06[idx]=  0xFE8C;
}
}else
{
if ((SeenChar(str06[idx]))
&& ((idx-1 >= 0) && (str06[idx-1]== 0x0020)))
str06[idx-1]=TAIL;
if ((!SeenChar(str06[idx]))
&& ((idx-1 >= 0) && (str06[idx-1]== TAIL)))
str06[idx-1]=0x0020;
if  (YeehHamzaChar(str06[idx]))
if ((idx-1 >= 0) && (str06[idx-1]== 0x0020))
{
if(str06[idx]== 0xFE89)
str06[idx]=  0xFEEF;
else
str06[idx]=  0xFEF0;
str06[idx-1]=  0xFE80;
}
else
{
if(str06[idx]== 0xFE89)
str06[idx]=  0xFE8B;
else
str06[idx]=  0xFE8C;
}
}
}
return str06;
}
/***********************************************************************************/
function ara_type (index,INPUT_STR,TXT_ORIENTATION_RTL)
{
var shapeStart= 0;
var shapeEnd= 0;
var displayStart= 0;
var displayEnd= 0;
var len= INPUT_STR.length;
var shapeBuff= new Array(len);
for (var idx0= 0;idx0 < len;idx0++)
shapeBuff[idx0]= INPUT_STR.charCodeAt(idx0);
if (len > index + 4)
{
shapeEnd= index + 4;
displayEnd= index + 2;
}else
if (len > index + 3)
{
shapeEnd= index + 3;
displayEnd= index + 2;
}else
if (len > index + 2)
{
shapeEnd= index + 2;
displayEnd= index + 2;
}else
if (len > index + 1)
{
shapeEnd= index + 1;
displayEnd= index + 1;
}else
if (len > index)
{
shapeEnd= index;
displayEnd= index;
}
if (index - 4 >= 0)
{
shapeStart= index - 4;
displayStart= index - 2;
}else
if (index - 3 >= 0)
{
shapeStart= index - 3;
displayStart= index - 2;
}else
if (index - 2 >= 0)
{
shapeStart= index - 2;
displayStart= index - 2;
}else
if (index - 1 >= 0)
{
shapeStart= index - 1;
displayStart= index - 1;
}else
if (index  >= 0.0)
{
shapeStart= index;
displayStart= index;
}
shapeBuff=  shape (TXT_ORIENTATION_RTL,shapeBuff,true);//@bd1c_ramysaid
var OUTPUT_BUFF= new Array(len);
for (var idx0= 0;idx0 < len;idx0++)
OUTPUT_BUFF[idx0]= INPUT_STR.charCodeAt(idx0);
var dstLen=shapeEnd - shapeStart + 1;
if(shapeEnd - shapeStart > 0)
{
for (var indx= shapeStart;indx <= shapeEnd;indx++)
OUTPUT_BUFF[indx]= shapeBuff[indx];
}
var retVal= "";
for(var idxt=0;idxt < OUTPUT_BUFF.length;idxt++){
retVal += String.fromCharCode(OUTPUT_BUFF[idxt]);
}
return retVal;
}
function ara_type_shape_all (INPUT_STR,TXT_ORIENTATION_RTL)
{
var shapeStart= 0;
var shapeEnd= 0;
var displayStart= 0;
var displayEnd= 0;
var len= INPUT_STR.length;
var shapeBuff= new Array(len);
for (var idx0= 0;idx0 < len;idx0++)
shapeBuff[idx0]= INPUT_STR.charCodeAt(idx0);
shapeEnd= len;
displayEnd= len;
shapeBuff=  shape (TXT_ORIENTATION_RTL,shapeBuff,true);
var OUTPUT_BUFF= new Array(len);
for (var idx0= 0;idx0 < len;idx0++)
OUTPUT_BUFF[idx0]= INPUT_STR.charCodeAt(idx0);
var dstLen=shapeEnd - shapeStart + 1;
if(shapeEnd - shapeStart > 0)
{
for (var indx= shapeStart;indx < shapeEnd;indx++)
OUTPUT_BUFF[indx]= shapeBuff[indx];
}
var retVal= "";
for(var idxt=0;idxt < OUTPUT_BUFF.length;idxt++){
if (((!TXT_ORIENTATION_RTL) && (OUTPUT_BUFF[idxt]== 0x20) && (idxt < (OUTPUT_BUFF.length - 1)) && (OUTPUT_BUFF[idxt+1] >= 0xFEF5) && (OUTPUT_BUFF[idxt+1] <= 0xFEFC))
|| ((TXT_ORIENTATION_RTL) && (OUTPUT_BUFF[idxt]== 0x20) && (idxt > 0) && (OUTPUT_BUFF[idxt-1] >= 0xFEF5) && (OUTPUT_BUFF[idxt-1] <= 0xFEFC))) {
} else {
retVal += String.fromCharCode(OUTPUT_BUFF[idxt]);
}
}
return retVal;
}
function expandLamAlef(INPUT_STR,length, visualmode, LeaveSpace)
{
var ExpandedArray= new Array();
var AlefType= [
0xFE81,
0xFE82,
0xFE83,
0xFE84,
0xFE87,
0xFE88,
0xFE8D,
0xFE8E,
];
var LamAlefNo= 0;
var NextSpace= false;
var LamAlefChar= false;
var FoundLamAlef= false;
var UniBuff= new Array(length);
for (var idx0= 0;idx0 < length;idx0++)
UniBuff[idx0]= INPUT_STR.charCodeAt(idx0);
for (var idx=0;idx < length;idx++)
{
var inputChar= UniBuff[idx];
LamAlefChar= ((inputChar >= 0xFEF5) && (inputChar <= 0xFEFC));
NextSpace= (((!visualmode) && (idx+1 < length) &&  (UniBuff[idx+1]== 0x20))
|| ((visualmode) &&(idx-1 >0) &&(UniBuff[idx-1]== 0x20)));
if  (LamAlefChar)
{
if (!NextSpace||LeaveSpace)
{
LamAlefNo++;
}
FoundLamAlef= true;
}
}
if (FoundLamAlef)
{
ExpandedArray= new Array(length + LamAlefNo);
var ChAlefType;
var trgidx= 0;
var idx=0;
while (idx < length)
{
var inputChar= UniBuff[idx];
var ggg=inputChar-0xFEF5;
if ((inputChar >= 0xFEF5) && (inputChar <= 0xFEFC))
{
if(visualmode){
NextSpace= ((idx-1 >0) &&(UniBuff[idx-1]== 0x20));
if(NextSpace&&!LeaveSpace)
trgidx--;
ChAlefType= AlefType[ggg];
ExpandedArray[trgidx]= ChAlefType;
trgidx++;
ExpandedArray[trgidx]= 0xFEDD;
}else{
ExpandedArray[trgidx]= 0xFEDD;
trgidx++;
ChAlefType= AlefType[ggg];
ExpandedArray[trgidx]= ChAlefType;
NextSpace= ((idx+1 < length) &&  (UniBuff[idx+1]== 0x20));
if (NextSpace&&!LeaveSpace)
idx++;
}
}else
ExpandedArray[trgidx]= UniBuff[idx];
trgidx++;
idx++;
}
return ExpandedArray;
}else
return UniBuff;
}
function deshape(strFE) {
var strFE_withLamAlefExpanded= expandLamAlef(strFE, strFE.length, true, true);
var str06= new Array(strFE_withLamAlefExpanded.length);
for (var i=0;i<strFE_withLamAlefExpanded.length;i++)
str06[i]= strFE_withLamAlefExpanded[i];
for (var i=0;i<strFE_withLamAlefExpanded.length;i++) {
if ((strFE_withLamAlefExpanded[i]==0xFE73) || (strFE_withLamAlefExpanded[i]==0x200B))
str06[i]= 0x20;
else if ((strFE_withLamAlefExpanded[i]>=0xFE70) && (strFE_withLamAlefExpanded[i]<=0xFEFF))
str06[i]= convertFEto06 [ (strFE_withLamAlefExpanded[i] - 0xFE70) ];
}
var retVal= "";
for(var idxt=0;idxt < str06.length;idxt++){
retVal += String.fromCharCode(str06[idxt]);
}
return retVal;
}
function getLamAlefsCountIn06Buffer(text, rtl) {
var lamAlefsCount= 0;
if (rtl) {
for (var i=1;i<(text.length);i++) {
if (text.charCodeAt(i-1)== 0x0644) {
if (isAlef(text.charCodeAt(i))) {
lamAlefsCount++;
}
}
}
} else {
for (var i=1;i<(text.length);i++) {
if (text.charCodeAt(i)== 0x0644) {
if (isAlef(text.charCodeAt(i-1))) {
lamAlefsCount++;
}
}
}
}
return lamAlefsCount;
}
function getLamAlefsCountInBufferRange(text, start, len, rtl) {
var lamAlefsCount= 0;
var i= start;
var myEnd= start + len;
if (rtl) {
while ((i<myEnd) && (i<text.length)) {
if (text.charCodeAt(i)== 0x0644) {
if (isAlef(text.charCodeAt(i+1))) {
lamAlefsCount++;
myEnd++;
}
}
i++;
}
if ((text.charCodeAt(i-1)== 0x0644) && isAlef(text.charCodeAt(i))) lamAlefsCount++;
} else {
while ((i<myEnd) && (i<text.length)) {
if (text.charCodeAt(i)== 0x0644) {
if (isAlef(text.charCodeAt(i-1))) {
lamAlefsCount++;
myEnd++;
}
}
i++;
}
if ((text.charCodeAt(i)== 0x0644) && isAlef(text.charCodeAt(i-1))) lamAlefsCount++;
}
return lamAlefsCount;
}
function getLamAlefsCountInFEBuffer(text, textLen) {
var lamAlefsCount= 0;
var i= 1;
var clipboardTextLen= textLen;
for (i=0;i<textLen;i++) {
if ((text.charCodeAt(i) >= 0xFEF5) && (text.charCodeAt(i) <= 0xFEFC))
lamAlefsCount++;
}
return lamAlefsCount;
}
function getAllFEshapesForChar(charFE) {
var strFEshapes= "";
var char06index= charFE - 0xFE70;
var char06= convertFEto06[char06index];
var start= 0, end= convertFEto06.length;
if ((char06index - 3) > start) start= char06index - 3;
if ((char06index + 3) < end) end= char06index + 3;
for (var i=start;i<=end;i++) {
if (char06== convertFEto06[i]) {
strFEshapes += String.fromCharCode(0xFE70 + i);
}
}
strFEshapes += String.fromCharCode(char06);
return strFEshapes;
}
}
/*
* Licensed Materials - Property of IBM
*
* WebSphere Development Studio Client for i5/OS - WebFacing
*
* visualfield_wf.js
*
*  Copyright IBM Corporation 2008, All Rights Reserved
*
* US Government Users Restricted Rights - Use, duplication or
* disclosure restricted by GSA ADP Schedule Contract with
* IBM Corp.
*/
var CODE_BACKSPACE= 8;
var CODE_TAB= 9;
var CODE_ENTER= 13;
var CODE_PAGEUP= 33;
var CODE_PAGEDOWN= 34;
var CODE_END= 35;
var CODE_HOME= 36;
var CODE_ARROWLEFT= 37;
var CODE_ARROWRIGHT= 39;
var CODE_ARROWUP= 38;
var CODE_ARROWDOWN= 40;
var CODE_INSERT= 45;
var CODE_DELETE= 46;
var CODE_A= 65;
var javascriptReorderer= null;
var adjustCaretOnKeyUp= false;
var focusField;
var isFldreversed= false;
var isWrappedField= false;
var maxFieldLen;
var curPos= 1;
var selectionStart= 1;
var autoPush= true;
var pushMode= false;
var rightPushBound= 0;
var leftPushBound= 0;
var layerGuess= false;
var swapChar= 0;
var hadnoFocus= true;
var preventAltNumpad= false;
var isOverwriteMozilla= false;
var isArabic= false;
var isLinux= (navigator.platform.indexOf("Linux") != -1) ? true : false;
var isIE= (navigator.appName== 'Microsoft Internet Explorer') ? true : false;
var LRO= String.fromCharCode(8237);
var RLO= String.fromCharCode(8238);
var fieldStart= 0;
var CR= (isIE) ? "\r\n" : "\n";
var LF= '\n';
var prevCharClass= false;
var hintForBiDiModes;
if(isIE) {
hintForBiDiModes= document.createElement("<div dir='ltr' id='bidi_vif_hint' style=\"BACKGROUND-COLOR: rgb(255,255,128);COLOR: black;BORDER-BOTTOM-STYLE: groove;BORDER-LEFT-STYLE: groove;BORDER-RIGHT-STYLE: groove;BORDER-TOP-STYLE: groove;FONT-FAMILY: serif;FONT-SIZE: x-small;HEIGHT: 80px;LEFT: 1px;POSITION: absolute;TOP: 1px;VISIBILITY: hidden;WIDTH: 250px;Z-INDEX: 1\"></div>");
hintForBiDiModes.innerText= "Field reverse-'Alt+Numpad Numlock'\nAuto push-'Alt+Numpad /'\nPush on-'Shift+Numpad Numlock'\nPush off-'Shift+Numpad /'";
}
else {
hintForBiDiModes= document.createElement("<div>");
hintForBiDiModes.setAttribute("dir","ltr");
hintForBiDiModes.setAttribute("id","bidi_vif_hint");
hintForBiDiModes.setAttribute("style","BACKGROUND-COLOR: rgb(255,255,128);COLOR: black;BORDER-BOTTOM-STYLE: groove;BORDER-LEFT-STYLE: groove;BORDER-RIGHT-STYLE: groove;BORDER-TOP-STYLE: groove;FONT-FAMILY: serif;FONT-SIZE: small;HEIGHT: 80px;LEFT: 1px;POSITION: absolute;TOP: 1px;VISIBILITY: hidden;WIDTH: 250px;Z-INDEX: 1");
if(isLinux)
hintForBiDiModes.innerHTML=  "Field reverse-'Shift+Numpad 4'<br\>Auto push-'Shift+Numpad 6'<br\>Push on-'Shift+Numpad 7'<br\>Push off-'Shift+Numpad 8'";
else
hintForBiDiModes.innerHTML=  "Field reverse-'Alt+Numpad Numlock'<br\>Auto push-'Alt+Numpad /'<br\>Push on-'Shift+Numpad Numlock'<br\>Push off-'Shift+Numpad /'";
}
function c_i_e_i_w_7101_getValueForValidation(obj){
var temp= c_i_e_i_w_7101_removeMarker(obj.value);
if (temp.length > 0)
{
if(obj.style.direction== "rtl")
{
temp= c_i_e_i_w_7101_reverseText(temp, obj);
}
}
return c_i_e_i_w_7101_applyShaping(obj,temp);
}
function c_i_e_i_w_7101_applyShaping(obj, temp){
if(isArabic)
{
temp= c_i_e_i_w_7101_wfInfoDB[obj.formId].shapingEngine.ara_type_shape_all(temp,false);
}
return temp;
}
function c_i_e_i_w_7101_getBidiOutputText(formId, text){//@bd2a_ramysaid
if (isArabic) {
text= c_i_e_i_w_7101_wfInfoDB[formId].shapingEngine.deshape(text);
}
text= text.replace(/&nbsp;/g, " ");
text= text.replace(/&lt;/g,   "<");
text= text.replace(/&gt;/g,   ">");
text= text.replace(/&amp;/g,  "&");
var jr= new c_i_e_i_w_7101_JSReorderSmartlogical();
text= jr.transformVisualToSL(text);
text= text.replace(/&/g, "&amp;");
text= text.replace(/ /g, "&nbsp;");
text= text.replace(/</g, "&lt;");
text= text.replace(/>/g, "&gt;");
return text;
}
function c_i_e_i_w_7101_removeMarker(text){
if (text.length > 0)
{
var marker= text.charAt(0);
if (marker== RLO || marker== LRO)
{
text= text.substring(1);
}
}
return text;
}
function c_i_e_i_w_7101_getSubmitValuePaddedWithSpaces(obj) {
var pad= "";
var f= c_i_e_i_w_7101_wfInfoDB[obj.formId][obj.id];
if(obj.dir== "rtl")
{
if(obj.style.wordWrap== "normal")
f.submitValue.replace(CR,"");
var rtlFieldShift= f.datalength - f.submitValue.length;
if(rtlFieldShift < 0) rtlFieldShift= 0;
var pad= "";
for(i= 0;i < rtlFieldShift;i++)
pad += ' ';
}
return  pad + f.submitValue;
}
function c_i_e_i_w_7101_addVIFHandlers(obj){//called after '_initializeBiDiField'
if (obj.readOnly)
{
} else {
if(isIE) {
obj.attachEvent("onkeypress",c_i_e_i_w_7101_handleKeyPress);
obj.attachEvent("onkeydown",c_i_e_i_w_7101_handleKeyDown);
obj.attachEvent("onkeyup",c_i_e_i_w_7101_handleKeyUp);
obj.attachEvent("onmouseup",c_i_e_i_w_7101_handleMouseUp);
obj.attachEvent("onmousedown",c_i_e_i_w_7101_handleMouseDown);
obj.attachEvent("onfocus",c_i_e_i_w_7101_handleFocus);
obj.attachEvent("ondblclick",c_i_e_i_w_7101_handleDblClick);
obj.attachEvent("onmouseout",c_i_e_i_w_7101_handleMouseOut);
obj.attachEvent("onblur",c_i_e_i_w_7101_handleBlur);
obj.attachEvent("onselect",c_i_e_i_w_7101_handleSelect);
obj.attachEvent("oncut",c_i_e_i_w_7101_handleCut);
obj.attachEvent("oncopy",c_i_e_i_w_7101_handleCopy);
obj.attachEvent("onpaste",c_i_e_i_w_7101_handlePaste);
obj.attachEvent("oncontextmenu",c_i_e_i_w_7101_updateBiDiCaretPos);
} else {
obj.addEventListener("onkeypress",c_i_e_i_w_7101_handleKeyPress, false);
obj.addEventListener("onkeydown",c_i_e_i_w_7101_handleKeyDown, false);
obj.addEventListener("onkeyup",c_i_e_i_w_7101_handleKeyUp, false);
obj.addEventListener("onmouseup",c_i_e_i_w_7101_handleMouseUp, false);
obj.addEventListener("onmousedown",c_i_e_i_w_7101_handleMouseDown, false);
obj.addEventListener("onfocus",c_i_e_i_w_7101_handleFocus, false);
obj.addEventListener("ondblclick",c_i_e_i_w_7101_handleDblClick, false);
obj.addEventListener("onmouseout",c_i_e_i_w_7101_handleMouseOut, false);
obj.addEventListener("onblur",c_i_e_i_w_7101_handleBlur, false);
}
}
isSoftWrapped= (obj.type.toLowerCase()== 'textarea') && (obj.wrap.toLowerCase()== "soft");
if(c_i_e_i_w_7101_wfInfoDB[obj.formId].BiDiWrap)
isSoftWrapped= false;
if(obj.dir== "rtl" && !isSoftWrapped) {
if(obj.type.toLowerCase()== 'textarea') {
obj.style.wordWrap= "normal";
obj.wrap= "hard";
}
obj.style.direction= "rtl";
obj.style.textAlign= "right";
} else {
obj.dir= "ltr";
obj.style.direction= "ltr";
obj.style.textAlign= "left";
}
if(obj.type.toLowerCase()== 'textarea'){
if(obj.wrap.toLowerCase() != "soft"){
if(isIE)
obj.style.wordWrap= "normal";
else
obj.setAttribute("wrap", "off");
}
}
else {
obj.maxLength += 1;
var f= c_i_e_i_w_7101_wfInfoDB[obj.formId][obj.id];
}
obj.value= c_i_e_i_w_7101_getBidiValueForDisplay(obj, obj.value);
if (isArabic) {
c_i_e_i_w_7101_adjustMaxLength(obj, obj.value);
}
obj.previousValue= obj.value;
obj.style.unicodeBidi= "bidi-override";
if(focusField== obj) {
c_i_e_i_w_7101_initializeGlobalVars(obj);
c_i_e_i_w_7101_ajustCaretForFocusField(obj);
c_i_e_i_w_7101_showStatusBar(obj);
}
}
function c_i_e_i_w_7101_handleSelect() {
var obj=  event.srcElement;
if(focusField== obj && document.selection.createRange().text.length== obj.value.length) {
fieldStart= (obj.type.toLowerCase()== 'textarea') ? 0 : 1;
if(obj.value.length > fieldStart)
c_i_e_i_w_7101_handleDblClick();
c_i_e_i_w_7101_preventDefault(event);
}
}
function c_i_e_i_w_7101_getBidiValueForDisplay(obj, text)
{
if (isArabic) {
text= c_i_e_i_w_7101_wfInfoDB[obj.formId].shapingEngine.deshape(text);
}
if((obj.style.wordWrap== "normal") && (obj.type.toLowerCase()== 'textarea')) {
c_i_e_i_w_7101_processLineWraps(obj, 0, false);//67660
text= obj.value;
}
if(obj.style.direction== "rtl") {
text= c_i_e_i_w_7101_reverseText(text, obj);
if((obj.type.toLowerCase()== 'text') && (text.charAt(0) != RLO))
text= RLO + text;
}
else if(obj.type.toLowerCase()== 'text')
{
if(text.charAt(0) != LRO)
text= LRO + text;
}
return text;
}
function c_i_e_i_w_7101_ajustCaretForFocusField(obj) {
var maxLen= obj.maxLength;
if(obj.type.toLowerCase() != 'textarea')
curPos++;
if(obj.dir== "rtl") {
var textLength= obj.value.length;
var rtlFieldShift= maxLen - textLength;
if(rtlFieldShift < 0) rtlFieldShift= 0;
curPos= textLength - (curPos - rtlFieldShift - fieldStart);
if(curPos > textLength) curPos= textLength;
c_i_e_i_w_7101_wfInfoDB[obj.formId].cursorPosColOffset= selectionStart= curPos;
}
if(isIE) {
c_i_e_i_w_7101_setSelectedRange(obj,curPos,curPos);
}
else {
obj.setSelectionRange(curPos,curPos);
}
selectionStart= curPos;
}
function c_i_e_i_w_7101_isOverWriteMode() {
if (isIE)
return document.queryCommandValue("OverWrite");
else
return isOverwriteMozilla;
}
function c_i_e_i_w_7101_reorderText(obj, text, isCalledFromCopy, isSL) {//67755
if(c_i_e_i_w_7101_wfInfoDB[obj.formId].javascriptReorderer== null)
c_i_e_i_w_7101_wfInfoDB[obj.formId].javascriptReorderer= new c_i_e_i_w_7101_JSReorder();
var resultText= "";
if(isCalledFromCopy && ((obj != null) && (obj.style.direction== "rtl"))) {//67755
var len= text.length;
for(i= 0;i < len;i++) {
symbol= text.charAt(len - i - 1);
symbol= c_i_e_i_w_7101_doSymSwap(symbol);
resultText += symbol;
}
} else
resultText= text;
var jr= new c_i_e_i_w_7101_JSReorderSmartlogical();
if(isSL){
resultText= jr.preventRoundTrip(resultText);
}
resultText= c_i_e_i_w_7101_wfInfoDB[obj.formId].javascriptReorderer.doReorder(resultText);
if(!isSL)                                             //GBR_c
resultText= jr.stripSpecialCharacters(resultText);//GBR_c
if(!isCalledFromCopy && ((obj != null) && (obj.style.direction== "rtl"))) {//67755
text= resultText;
resultText= "";
var len= text.length;
for(i= 0;i < len;i++) {
symbol= text.charAt(len - i - 1);
symbol= c_i_e_i_w_7101_doSymSwap(symbol);
resultText += symbol;
}
}
return resultText;
}
function c_i_e_i_w_7101_processCopy(obj) {
if(isIE) {
range= document.selection.createRange();
text= range.text;
}
else
text= obj.value.substring(obj.selectionStart,obj.selectionEnd);
if((text.charAt(0)== LRO) || (text.charAt(0)== RLO))
text= text.substring(1);
textToClipboard= c_i_e_i_w_7101_reorderText(obj, text, true, true);//67755
if(isIE) {
window.clipboardData.setData("Text", textToClipboard);
return true;
}
}
function c_i_e_i_w_7101_ajustCaretPositions(event_,obj) {
var selection= c_i_e_i_w_7101_getCaretPos(event_,obj);
if (selection){
selectionStart= Math.min(selection[0],selection[1]);
curPos= Math.max(selection[0],selection[1]);
if(selectionStart== curPos && obj.value.charAt(curPos)== '\r' && obj.value.charAt(curPos+1)== LF) {
selectionStart= curPos= curPos + 2;
c_i_e_i_w_7101_setSelectedRange(obj,curPos,curPos);
}
}
c_i_e_i_w_7101_preventEraseMarker(obj);
}
function c_i_e_i_w_7101_handleCopy() {
var obj= (isIE) ? event.srcElement : event.target;
c_i_e_i_w_7101_preventDefault(event);
return c_i_e_i_w_7101_processCopy(obj);
}
function c_i_e_i_w_7101_handleCut() {
var obj= (isIE) ? event.srcElement : event.target;
if(pushMode) {
if(isIE)
c_i_e_i_w_7101_updatePushBounds(leftPushBound - Math.abs(selectionStart - curPos),true);
else
c_i_e_i_w_7101_updatePushBounds(leftPushBound - Math.abs(obj.selectionStart - obj.selectionEnd),true);
}
var ret= c_i_e_i_w_7101_processCopy(obj);
if(!ret) return false;
if(isIE) {
curPos= Math.min(selectionStart,curPos);
selectionStart= curPos;
c_i_e_i_w_7101_preventDefault(event);
range= document.selection.clear();
}
else {
curPos= obj.selectionStart;
obj.value= obj.value.substring(0,curPos) + obj.value.substring(obj.selectionEnd);
obj.setSelectionRange(curPos,curPos);
}
if(obj.style.wordWrap== "normal")
c_i_e_i_w_7101_processLineWraps(obj, curPos, true);//67660
return true;
}
function c_i_e_i_w_7101_handlePaste() {
var obj= (isIE) ? event.srcElement : event.target;
c_i_e_i_w_7101_preventDefault(event);
var range= document.selection.createRange();
var clipboardText= window.clipboardData.getData("Text");
if (isArabic) {
clipboardText= c_i_e_i_w_7101_wfInfoDB[obj.formId].shapingEngine.ara_type_shape_all(clipboardText,true);
}
var clipboardTextLen= clipboardText.length;
selectionStart= Math.min(selectionStart, curPos);
clipboardTextLen= Math.min(clipboardTextLen,maxFieldLen - selectionStart);
delta= clipboardTextLen - (range.text).length;
if (isArabic) {
var lamAlefsInField= c_i_e_i_w_7101_wfInfoDB[obj.formId].shapingEngine.getLamAlefsCountInBufferRange(obj.value, selectionStart, clipboardTextLen, obj.style.direction=="rtl");
delta += lamAlefsInField;
}
if(delta > 0) {
if(obj.value.length < selectionStart + clipboardTextLen)
delta= obj.value.length - (selectionStart + (range.text).length);
range.moveEnd("character",delta);
}
range.text= c_i_e_i_w_7101_reorderText(obj,clipboardText.substring(0,clipboardTextLen),false, false);//GBR_c
if (isArabic) {
var deshapedObjectValue= obj.value;
if (obj.style.direction=="rtl") {
deshapedObjectValue= c_i_e_i_w_7101_reverse(deshapedObjectValue);
}
deshapedObjectValue= c_i_e_i_w_7101_wfInfoDB[obj.formId].shapingEngine.deshape(deshapedObjectValue);
if (obj.style.direction=="rtl") {
deshapedObjectValue= c_i_e_i_w_7101_reverse(deshapedObjectValue);
}
c_i_e_i_w_7101_adjustMaxLength(obj, deshapedObjectValue);
obj.value= deshapedObjectValue;
var lamAlefsInClipboard= c_i_e_i_w_7101_wfInfoDB[obj.formId].shapingEngine.getLamAlefsCountInFEBuffer(clipboardText, clipboardTextLen);
selectionStart= curPos= selectionStart + clipboardTextLen + lamAlefsInClipboard;
} else {
selectionStart= curPos= selectionStart + clipboardTextLen;
}
if(fieldStart > 0)
adjustCaretOnKeyUp= true;
if(pushMode)
c_i_e_i_w_7101_toggleFieldOrient(obj,true,false);
c_i_e_i_w_7101_onSelectUpdateCursorOffset(obj);
if(obj.style.wordWrap== "normal")
c_i_e_i_w_7101_processLineWraps(obj, curPos, true);//67660
}
function c_i_e_i_w_7101_handleDblClick() {
var obj= (isIE) ? event.srcElement : event.target;
fieldStart= (obj.type.toLowerCase()== 'textarea') ? 0 : 1;
if(pushMode) {
if(!isWrappedField && ((curPos > leftPushBound)||(selectionStart < rightPushBound)) ||
isWrappedField && ((curPos < leftPushBound)||(selectionStart > rightPushBound)))
c_i_e_i_w_7101_toggleFieldOrient(obj,false,false);
}
c_i_e_i_w_7101_ajustCaretPositions(event,obj);
}
function c_i_e_i_w_7101_getCaretPos(event,obj) {
if(!isIE) {
return new Array(event.target.selectionStart, event.target.selectionEnd);
}
else {
var range= document.selection.createRange().duplicate();
var range2= range.duplicate();
var rangeLength= range.text.length;
if(range2.parentElement(0) != obj)
return null;
if (obj.type.toLowerCase()== 'textarea')
range2.moveToElementText(obj);
else
range2.expand('textedit');
var isLeftBoundaryPosition= range2.offsetLeft== range.offsetLeft;
while (range.compareEndPoints('StartToStart', range2) > 0) {
range.moveStart('character', -1);
}
var position= range.text.length;
if (obj.type.toLowerCase()== 'textarea' && (obj.value.charAt(position)== '\r')) {
if(((event.type != "mouseup" || rangeLength== 0) && isLeftBoundaryPosition) //mouse click or up/down
||(event.type== "mouseup" && !isLeftBoundaryPosition && (event.offsetX < 5) && (event.offsetX > 0))) //mouse selection
position += 2;
}
return new Array(position - rangeLength, position);
}
}
function c_i_e_i_w_7101_handleMouseDown() {
if(isIE)
var obj= event.srcElement;
if(event.button== 2 && c_i_e_i_w_7101_wfInfoDB[obj.formId].showBiDiHint) {
var hint= document.getElementById("bidi_vif_hint");
if(hint== null)
document.body.appendChild(hintForBiDiModes);
hint= document.getElementById("bidi_vif_hint");
if(hint != null) {
var hintElement= (hint.length > 0) ? hint[0] : hint;
hintElement.style.left=(event.clientX >= hint.scrollWidth) ? (event.clientX - hint.scrollWidth) : 0;
hintElement.style.top=event.clientY;
hintElement.style.visibility= "visible";
}
}
if(isIE) {
fieldStart= (obj.type.toLowerCase()== 'textarea') ? 0 : 1;
if(selectionStart != curPos)
c_i_e_i_w_7101_setSelectedRange(obj,fieldStart,fieldStart);
}
}
function c_i_e_i_w_7101_updateBiDiCaretPos() {
try{
var obj= event.srcElement;
if(focusField== obj) {
var selection= c_i_e_i_w_7101_getCaretPos(event,obj);
if(selection) {
selectionStart= Math.min(selection[0],selection[1]);
curPos= Math.max(selection[0],selection[1]);
}
}
} catch(e){}
}
function c_i_e_i_w_7101_handleMouseUp() {
var obj= (isIE) ? event.srcElement : event.target;
if(obj != focusField)
obj= focusField;
if(c_i_e_i_w_7101_wfInfoDB[obj.formId].showBiDiHint) {
var hint= document.getElementById("bidi_vif_hint");
if(hint != null) {
if(hint.length > 0)
hint[0].style.visibility= "hidden";
else
hint.style.visibility= "hidden";
}
}
if(event.button != 2)
c_i_e_i_w_7101_ajustCaretPositions(event,obj);
if(pushMode) {
if(!isWrappedField && ((curPos > leftPushBound)||(selectionStart < rightPushBound)) ||
isWrappedField && ((curPos < leftPushBound)||(selectionStart > rightPushBound)))
c_i_e_i_w_7101_toggleFieldOrient(obj,true,false);
}
}
function c_i_e_i_w_7101_handleBlur() {
var obj= obj= (isIE) ? event.srcElement : event.target;
if(!isLinux || !preventAltNumpad) {
if(pushMode) {
c_i_e_i_w_7101_toggleFieldOrient(obj,false,false);
pushMode= false;
}
if (isFldreversed)
c_i_e_i_w_7101_processFieldReverse(obj,false);
}
}
function c_i_e_i_w_7101_initializeBiDiField(tagId, formId, ccsid, _curPos) {
var form= document.forms[formId];
var field= form.elements(tagId);
if (c_i_e_i_w_7101_isValidRef(field)){
focusField= field;
isArabic= (ccsid== 420);
if(isArabic)
c_i_e_i_w_7101_wfInfoDB[formId].shapingEngine= new c_i_e_i_w_7101_JSShapingEngine();
if ((field.type != "hidden")&&(true != field.readOnly)&&(_curPos != null)) {
selectionStart= curPos= _curPos;
}
}
}
function c_i_e_i_w_7101_initializeGlobalVars(obj) {
isFldreversed= false;
isWrappedField= false;
if(obj.type.toLowerCase()== 'textarea') {
if(obj.wrap.toLowerCase()== "soft")
isWrappedField= true;
fieldStart= 0;
}
else {
fieldStart= 1;
}
maxFieldLen= obj.maxLength;
if(maxFieldLen <= 0)
maxFieldLen= 100000;
}
function c_i_e_i_w_7101_handleFocus() {
var obj= (isIE) ? event.srcElement : event.target;
isArabic= c_i_e_i_w_7101_wfInfoDB[obj.formId].hostJobCCSID== 420;
c_i_e_i_w_7101_initializeGlobalVars(obj);
focusField= obj;
fieldStart= (obj.type== "textarea") ? 0 : 1;
c_i_e_i_w_7101_ajustCaretPositions(event,obj)
if(isLinux && (curPos > 0))
obj.setSelectionRange(curPos,curPos);
c_i_e_i_w_7101_showStatusBar(obj);
}
function c_i_e_i_w_7101_handleMouseOut() {
var obj= (isIE) ? event.srcElement : event.target;
var hint= document.getElementById("bidi_vif_hint");
if(hint != null) {
if(hint.length > 0)
hint[0].style.visibility= "hidden";
else
hint.style.visibility= "hidden";
}
}
function c_i_e_i_w_7101_swapBrackets(event,fieldDirection,swapped) {
if(isLinux) {
if(fieldDirection ^ (layerGuess && !isArabic)) {
if(swapped== 40)
swapped=  41;
else if(swapped== 41)
swapped= 40;
else if(swapped== 60)
swapped= 62;
else if(swapped== 62)
swapped= 60;
else if(swapped== 91)
swapped= 93;
else if(swapped== 93)
swapped= 91;
else if(swapped== 123)
swapped= 125;
else if(swapped== 125)
swapped= 123;
}
return swapped;
}
else
if(fieldDirection) {
if(swapChar== 219) {
if (isArabic)
swapped= 62;
else
swapped= (event.shiftKey) ? 125 : 93;
}
else if(swapChar== 221) {
if (isArabic)
swapped= 60;
else
swapped= (event.shiftKey) ? 123 : 91;
}
else if(swapChar== 48)
swapped= 40;
else if(swapChar== 57)
swapped= 41;
else if(swapChar== 188)
swapped= 62;
else if(swapChar== 190)
swapped= 60;
}
else {
if(swapChar== 219) {
if (isArabic)
swapped= 60;
else
swapped=  (event.shiftKey) ? 123 : 91;
}
else if(swapChar== 221) {
if (isArabic)
swapped= 62;
else
swapped=  (event.shiftKey) ? 125 : 93;
}
else if(swapChar== 48)
swapped= 41;
else if(swapChar== 57)
swapped= 40;
else if(swapChar== 188)
swapped= 60;
else if(swapChar== 190)
swapped= 62;
}
swapChar= 0;
return swapped;
}
function c_i_e_i_w_7101_normalizeSelectionBounds(obj) {
if(isIE){
var range= document.selection.createRange();
if(range.text.length != 0) {
tmpMin= Math.min(selectionStart,curPos);
curPos= Math.max(selectionStart,curPos);
selectionStart= tmpMin;
}
}
else {
selectionStart= obj.selectionStart;
curPos= obj.selectionEnd;
}
if(selectionStart < fieldStart) selectionStart= fieldStart;
}
function c_i_e_i_w_7101_processWrappedField(obj,ieKey) {
c_i_e_i_w_7101_preventDefault(event);
if(c_i_e_i_w_7101_isOverWriteMode() && (selectionStart== curPos) && (curPos <= fieldStart)) {
if((curPos== leftPushBound) && (obj.value.length < maxFieldLen)){
c_i_e_i_w_7101_updatePushBounds(1,true);
obj.value= obj.value.substring(0,curPos) + String.fromCharCode(ieKey) + obj.value.substring(curPos);
c_i_e_i_w_7101_setSelectedRange(obj,curPos,curPos);
}
return;
}
c_i_e_i_w_7101_updatePushBounds(1 - (curPos - selectionStart),curPos != selectionStart);
if((curPos== selectionStart) && c_i_e_i_w_7101_isOverWriteMode()) {
selectionStart= curPos= curPos - 1;
obj.value= obj.value.substring(0,curPos) + String.fromCharCode(ieKey) + obj.value.substring(curPos+1);
}
else {
obj.value= obj.value.substring(0,selectionStart) + String.fromCharCode(ieKey) + obj.value.substring(curPos);
selectionStart= curPos= Math.min(selectionStart,curPos);
}
c_i_e_i_w_7101_setSelectedRange(obj,curPos,curPos);
}
function c_i_e_i_w_7101_processLineWraps(obj, position, processCaret) {//67660
var length= obj.value.length;
var lineStart= 0, lineEnd;
var buffer= "";
if(position > obj.cols + 1) {//find line start
for(i=position;i>0;i--) {
if(obj.value.charAt(i)== LF) {
lineStart= i+1;break;
}
}
buffer= obj.value.substring(0,lineStart);
}
while(lineStart < length) {
lineEnd= lineStart + obj.cols + 1;
if(lineEnd > length) {
buffer += obj.value.substring(lineStart).replace(CR,' ');
break;
}
indexCR= obj.value.substring(lineStart,lineEnd + 1).lastIndexOf(CR);
index= obj.value.substring(lineStart,lineEnd).lastIndexOf(' ');
if(index== -1) // long line
index= obj.value.substring(lineEnd).indexOf(' ');
if(index != -1) {
if(indexCR != -1 && index < indexCR) {//no need to reformat
buffer= buffer + obj.value.substring(lineStart,lineStart+indexCR).replace(CR,' ') + CR;
lineStart += (indexCR + 2);
continue;
}
oldString= obj.value.substring(lineStart,lineStart+index);
if(curPos > index && indexCR== -1)
selectionStart= curPos= curPos + 1;
buffer= buffer + oldString.replace(CR,' ') + CR;
}
else {//one long line
index= length;
buffer += obj.value.substring(lineStart,lineStart+index).replace(CR,' ');
}
lineStart += (index + 1);
}
obj.value= buffer;
if(processCaret) //67660
c_i_e_i_w_7101_setSelectedRange(obj,curPos,curPos);
var delta= obj.value.length - length;
if(delta != 0)
maxFieldLen= obj.maxLength= parseInt(obj.maxLength) + delta;
}
function c_i_e_i_w_7101_handleKeyPress() {
if(event== null)
return;
if(preventAltNumpad || (event.returnValue== false)) {
c_i_e_i_w_7101_preventDefault(event);
return;
}
var replacedKey= null;
var obj= (isIE) ? event.srcElement : event.target;
if(isWrappedField)
charClass= pushMode;
else
charClass= fieldDirection= (obj.style.direction== "rtl");
if (isArabic) {
c_i_e_i_w_7101_adjustMaxLength(obj, obj.value);
}
if(isIE) {
if(event.returnValue== false)
return;
event.keyCode= c_i_e_i_w_7101_swapBrackets(event,fieldDirection,event.keyCode);
ieKey= event.keyCode;
if(isArabic && layerGuess && (ieKey > 47) && (ieKey < 58))//Arabic, transform into Hindi
ieKey= event.keyCode= ieKey + 1584;
}
else {
ieKey= event.charCode;
if(event.keyCode== CODE_INSERT) {
isOverwriteMozilla= !isOverwriteMozilla;
}
else if((ieKey > 31) & !event.altKey & !event.ctrlKey) {//regular character
charCode= c_i_e_i_w_7101_swapBrackets(event,fieldDirection,event.charCode);
if(charCode != ieKey) {
replacedKey= charCode;
}
else if(isArabic && layerGuess && (ieKey > 47) && (ieKey < 58)) {//Arabic, transform into Hindi
replacedKey= ieKey + 1584;
}
}
}
if((event.keyCode== CODE_ENTER) && (obj.rows== 1)){
c_i_e_i_w_7101_preventDefault(event);
return;
}
if(!isIE && ((event.keyCode== 8) || (event.keyCode== 46)))
return;
if(((ieKey > 64) & (ieKey < 91)) || ((ieKey > 96) & (ieKey < 123)))
layerGuess= charClass= false;//English
else if(ieKey > 1487) {
layerGuess= charClass= true;
if(ieKey > 1547)
isArabic= true;
}
if(prevCharClass != charClass) {
prevCharClass= charClass;
c_i_e_i_w_7101_showStatusBar(obj);
}
if(autoPush) {
if(fieldDirection && ((ieKey > 47) && (ieKey < 58))) {
if(!layerGuess || (obj.style.textAlign== "right"))
charClass= false;//English (Numerals)
}
if((!isWrappedField && (fieldDirection != charClass)) || (isWrappedField && (pushMode != charClass))) {//enter/leave push mode
curPos= (isIE) ? curPos : obj.selectionEnd;
c_i_e_i_w_7101_toggleFieldOrient(obj,true,pushMode && (curPos== leftPushBound));
}
}
if((ieKey > 31) && !event.altKey && !event.ctrlKey) {//regular character
c_i_e_i_w_7101_preventEraseMarker(obj);
var cursorPos= (isIE) ? curPos : obj.selectionStart;
var selectionLength= (isIE) ? Math.abs(selectionStart - curPos) : obj.selectionEnd - obj.selectionStart;
if (isArabic) {
var virtualbuffer= "";
replacedKey= (replacedKey != null) ? replacedKey : ieKey;
if(c_i_e_i_w_7101_isOverWriteMode() && (selectionStart== curPos))
virtualbuffer= obj.value.substring(0,cursorPos) + String.fromCharCode(replacedKey) + obj.value.substring(cursorPos+1);
else
virtualbuffer= obj.value.substring(0,cursorPos) + String.fromCharCode(replacedKey) + obj.value.substring(cursorPos);
c_i_e_i_w_7101_adjustMaxLength(obj, virtualbuffer);
}
if(!c_i_e_i_w_7101_isOverWriteMode() || (selectionLength > 0)) {
if(obj.value.length - selectionLength >= maxFieldLen) {
c_i_e_i_w_7101_preventDefault(event);
return;
}
}
else {
if (cursorPos >= maxFieldLen) {
c_i_e_i_w_7101_preventDefault(event);
return;
}
}
c_i_e_i_w_7101_normalizeSelectionBounds(obj);
if(pushMode) {
if(isWrappedField) {
c_i_e_i_w_7101_processWrappedField(obj,ieKey);
return;
}
c_i_e_i_w_7101_updatePushBounds(1 - selectionLength,selectionLength > 0);
}
if(isIE) {
if(curPos != selectionStart) {
c_i_e_i_w_7101_preventDefault(event);
var range= document.selection.createRange();
range.text= String.fromCharCode(ieKey);
range.select();
}
selectionStart= curPos= Math.min(selectionStart,curPos) + 1;
}
else {
if(isLinux && fieldDirection && isArabic && (ieKey > 1487)) {
replacedKey= (replacedKey != null) ? replacedKey : ieKey;
event.preventDefault();
curPos= obj.selectionStart;
if(c_i_e_i_w_7101_isOverWriteMode() && (obj.selectionStart== obj.selectionEnd))
text= obj.value.substring(0,obj.selectionStart) + String.fromCharCode(replacedKey) + obj.value.substring(obj.selectionEnd+1);
else
text= obj.value.substring(0,obj.selectionStart) + String.fromCharCode(replacedKey) + obj.value.substring(obj.selectionEnd);
obj.value= c_i_e_i_w_7101_wfInfoDB[obj.formId].shapingEngine.ara_type(obj.selectionStart,text,fieldDirection);
obj.setSelectionRange(curPos+1,curPos+1);
}
else if((replacedKey != null) || c_i_e_i_w_7101_isOverWriteMode()) {
replacedKey= (replacedKey != null) ? replacedKey : ieKey;
event.preventDefault();
c_i_e_i_w_7101_replaceFieldText(obj,replacedKey);
}
}
}
}
function c_i_e_i_w_7101_replaceFieldText(obj,characterCode) {
curPos= obj.selectionStart;
if(c_i_e_i_w_7101_isOverWriteMode() && (obj.selectionStart== obj.selectionEnd))
obj.value= obj.value.substring(0,obj.selectionStart) + String.fromCharCode(characterCode) + obj.value.substring(obj.selectionEnd+1);
else
obj.value= obj.value.substring(0,obj.selectionStart) + String.fromCharCode(characterCode) + obj.value.substring(obj.selectionEnd);
obj.setSelectionRange(curPos+1,curPos+1);
}
function c_i_e_i_w_7101_handleKeyUp() {
var ieKey= event.keyCode;
var obj= (isIE) ? event.srcElement : event.target;
fieldDirection= (obj.style.direction== "ltr") ? false : true;
if(!isIE)
curPos= obj.selectionStart;
if ((ieKey== CODE_ARROWLEFT) || (ieKey== CODE_ARROWRIGHT)) {
if(pushMode && c_i_e_i_w_7101_isOutsidePushBounds())
c_i_e_i_w_7101_toggleFieldOrient(obj,true,false);
}
else if (ieKey== CODE_ARROWUP || ieKey== CODE_ARROWDOWN || (event.shiftKey && (ieKey== CODE_HOME || ieKey== CODE_END))) {
if(pushMode)
c_i_e_i_w_7101_toggleFieldOrient(obj,true,false);
c_i_e_i_w_7101_ajustCaretPositions(event,obj);
}
else if (ieKey== CODE_HOME || ieKey== CODE_PAGEUP)
c_i_e_i_w_7101_processHome(obj,event);
else if (ieKey== CODE_END || ieKey== CODE_PAGEDOWN)
c_i_e_i_w_7101_processEnd(obj,event);
else if(isIE && (obj.style.wordWrap== "normal")) {
if ((ieKey== CODE_DELETE) || (ieKey== CODE_BACKSPACE) || ((ieKey > 31) && (ieKey != CODE_INSERT) && (ieKey != 144) && !event.altKey && !event.ctrlKey))
c_i_e_i_w_7101_processLineWraps(obj, curPos, true);//67660
}
else if(adjustCaretOnKeyUp){
c_i_e_i_w_7101_setSelectedRange(obj,selectionStart,curPos);
adjustCaretOnKeyUp= false;
}
else if(ieKey== 27) //67662 process escape
c_i_e_i_w_7101_handleEscape();
}
function c_i_e_i_w_7101_handleEscape() {//67662
var j;
var elements= document.getElementsByTagName("input");
for(j=0;j < elements.length;j++) {
firstChar= elements[j].value.charAt(0);
if (elements[j].style.unicodeBidi== "bidi-override" && firstChar != LRO && firstChar != RLO) {
elements[j].value= c_i_e_i_w_7101_getBidiValueForDisplay(elements[j], elements[j].value);
}
}
var elements= document.getElementsByTagName("textarea");
for(j=0;j < elements.length;j++) {//has bug for RTL hard wrapped fields
if (elements[j].style.unicodeBidi== "bidi-override") {
elements[j].value= c_i_e_i_w_7101_getBidiValueForDisplay(elements[j], elements[j].value);
}
}
}
function c_i_e_i_w_7101_handleKeyDown() {
if(event== null)
return;
var ieKey= event.keyCode;
var obj= (isIE) ? event.srcElement : event.target;
if (isArabic) {
c_i_e_i_w_7101_adjustMaxLength(obj, obj.value);
}
if(ieKey== 18)
preventAltNumpad= true;
else if(!event.altKey)
preventAltNumpad= false;
fieldDirection= (obj.style.direction== "ltr") ? false : true;
if(event.shiftKey && (ieKey== 48 || ieKey== 57))
swapChar= ieKey;
else if((ieKey== 219)||(ieKey== 221)) {
if(isArabic) {
if(event.shiftKey && layerGuess)
swapChar= ieKey;
}
else
swapChar= ieKey;
}
else if(event.shiftKey && (ieKey== 188 || ieKey== 190)) {
swapChar= (isArabic) ? 0 : ieKey;
}
if(event.shiftKey)
c_i_e_i_w_7101_processPush(obj,ieKey);
if((!isLinux && event.shiftKey && event.altKey) || (isLinux && (ieKey== 18))) {
layerGuess= !layerGuess;
c_i_e_i_w_7101_showStatusBar(obj);
}
if((event.altKey && !isLinux) || (event.shiftKey && isLinux)) {
if(((ieKey== 111) && !isLinux) || ((ieKey== 102) && isLinux)) {//Toggle Autopush
autoPush= !autoPush;
if(pushMode)
c_i_e_i_w_7101_toggleFieldOrient(obj,true,false);
preventAltNumpad= true;
c_i_e_i_w_7101_showStatusBar(obj);
}
else if(((ieKey== 144) && !isLinux) || ((ieKey== 100) && isLinux)) {//Field reverse
c_i_e_i_w_7101_processFieldReverse(obj,true);
preventAltNumpad= true;
}
}
else if (ieKey== CODE_BACKSPACE) {
c_i_e_i_w_7101_processBackspace(obj,event);
}
else if (ieKey== CODE_DELETE) {
c_i_e_i_w_7101_processDelete(obj);
}
else if(ieKey== CODE_ENTER) {
if(pushMode) {
c_i_e_i_w_7101_toggleFieldOrient(obj,false,false);
pushMode= false;
}
if (isFldreversed)
c_i_e_i_w_7101_processFieldReverse(obj,false);
}
else if(isIE) {
if ((ieKey== CODE_HOME)||(ieKey== CODE_END)||(ieKey== CODE_PAGEUP)||(ieKey== CODE_PAGEDOWN)) {
if(!event.shiftKey)
c_i_e_i_w_7101_preventDefault(event);//disable, process it in KeyUp
}
else if (((ieKey== CODE_ARROWLEFT) & (fieldDirection== 0))|((ieKey== CODE_ARROWRIGHT) & (fieldDirection== 1))) {
c_i_e_i_w_7101_processLeftarrow(obj);
}
else if (((ieKey== CODE_ARROWRIGHT) & (fieldDirection== 0))|((ieKey== CODE_ARROWLEFT) & (fieldDirection== 1))) {
c_i_e_i_w_7101_processRightarrow(obj);
}
}
else if (event.ctrlKey && (ieKey== 88 || ieKey== 67 || ieKey== 86)) {//copy/paste/cut for firefox
c_i_e_i_w_7101_preventEraseMarker(obj);
}
}
function c_i_e_i_w_7101_preventDefault(event) {
if(isIE)
event.returnValue= false;
else
event.preventDefault();
}
function c_i_e_i_w_7101_doSymSwap(symbol) {
switch(symbol)
{
case "(":
symbol= ")";
break;
case ")":
symbol= "(";
break;
case "{":
symbol= "}";
break;
case "}":
symbol= "{";
break;
case "[":
symbol= "]";
break;
case "]":
symbol= "[";
break;
case "<":
symbol= ">";
break;
case ">":
symbol= "<";
break;
}
return symbol;
}
function c_i_e_i_w_7101_setSelectedRange(obj,selectionStartMod,curPosMod){
if(isIE) {
var range= obj.createTextRange();
if (range){
if (obj.type.toLowerCase()== 'textarea') {
range.moveToElementText(obj);
len= curPosMod;
for(var i= fieldStart;i < len;i++){
if((obj.value.charAt(i)== '\r')) {
selectionStartMod--;
curPosMod--;
}
}
}
else
range.expand('textedit');
range.collapse();
range.moveEnd('character', curPosMod);
range.moveStart('character', selectionStartMod);
range.select();
}
} else {
obj.setSelectionRange(selectionStartMod,curPosMod);
}
}
function c_i_e_i_w_7101_processHome(obj,event) {
var boundaries= c_i_e_i_w_7101_getLineBoundaries(obj);
var lineStart= (obj.type.toLowerCase()== 'textarea') ? boundaries[0] + 1 : boundaries[0];
var lineEnd= (obj.type.toLowerCase()== 'textarea') ? boundaries[1] : boundaries[1] + 1;
if(pushMode)
selectionStart= curPos= lineEnd;
else
selectionStart= curPos= lineStart;
c_i_e_i_w_7101_setSelectedRange(obj,selectionStart,curPos);
if(pushMode && c_i_e_i_w_7101_isOutsidePushBounds())
c_i_e_i_w_7101_toggleFieldOrient(obj,true,false);
c_i_e_i_w_7101_preventDefault(event);
}
function c_i_e_i_w_7101_processEnd(obj,event) {
var boundaries= c_i_e_i_w_7101_getLineBoundaries(obj);
var lineStart= (obj.type.toLowerCase()== 'textarea') ? boundaries[0] + 1 : boundaries[0];
var lineEnd= (obj.type.toLowerCase()== 'textarea') ? boundaries[1] : boundaries[1] + 1;
if(pushMode)
selectionStart= curPos= lineStart;
else
selectionStart= curPos= lineEnd;
c_i_e_i_w_7101_setSelectedRange(obj,selectionStart,curPos);
if(pushMode && c_i_e_i_w_7101_isOutsidePushBounds())
c_i_e_i_w_7101_toggleFieldOrient(obj,true,false);
c_i_e_i_w_7101_preventDefault(event);
}
function c_i_e_i_w_7101_translatePosFromBiDiToNormal(obj) {
fieldStart= (obj.type.toLowerCase()== 'textarea') ? 0 : 1;
var boundaries= c_i_e_i_w_7101_getLineBoundaries(obj);
var selection= c_i_e_i_w_7101_getCaretPos(event,obj);
var rtlFieldShift= (obj.dir== "rtl") ? obj.maxLength - obj.value.length : 0;
var pos= rtlFieldShift + ((selection) ? selection[0] : curPos);
if(obj.style.direction== "rtl")
pos= boundaries[1] + 1 - pos + boundaries[0];
if (isArabic) {
if (obj.style.direction== "rtl")
subString= obj.value.substring(selection[0]);
else
subString= obj.value.substring(0,selection[0]);
var lamAlefs= c_i_e_i_w_7101_wfInfoDB[obj.formId].shapingEngine.getLamAlefsCountIn06Buffer(subString, obj.style.direction== "rtl");
if (lamAlefs > 0)
pos -=  lamAlefs;
}
return (pos - fieldStart);
}
function c_i_e_i_w_7101_getLineBoundaries(obj) {
var len= obj.value.length;
var lineStart= fieldStart, lineEnd= len - 1;
if (obj.type.toLowerCase()== 'textarea') {
var selectionStart_= (isIE) ? selectionStart : obj.selectionStart;
for(lineStart= selectionStart_;lineStart >= fieldStart;lineStart--){
if(obj.value.charAt(lineStart)== LF)
break;
}
for(lineEnd= curPos;lineEnd < len;lineEnd++){
if((obj.value.charAt(lineEnd)== LF) || (obj.value.charAt(lineEnd)== '\r'))
break;
}
}
return new Array(lineStart,lineEnd);
}
function c_i_e_i_w_7101_toggleFieldOrient(obj,setCursor,jumpFromPushSegment) {
var delta= 0;
if(!isIE) {
selectionStart= obj.selectionStart;
curPos= obj.selectionEnd;
}
if(isWrappedField) {
if(setCursor) {
pushMode= !pushMode;
if(pushMode)
leftPushBound= rightPushBound= selectionStart;
else if(jumpFromPushSegment && !pushMode) {
selectionStart= curPos=rightPushBound;
c_i_e_i_w_7101_setSelectedRange(obj,selectionStart,curPos);
}
}
c_i_e_i_w_7101_showStatusBar(obj);
return;
}
obj.style.direction= (obj.style.direction== "rtl") ? "ltr" : "rtl";
if(obj.value.charAt(0)== LRO)
obj.value= RLO + obj.value.substring(1);
else if(obj.value.charAt(0)== RLO)
obj.value= LRO + obj.value.substring(1);
var boundaries= c_i_e_i_w_7101_getLineBoundaries(obj);
obj.value= c_i_e_i_w_7101_reverseText(obj.value,obj);
if(setCursor) {
var lineStart= boundaries[0];
var lineEnd= boundaries[1];
pushMode= !pushMode;
if(pushMode) {
delta= Math.abs(selectionStart - curPos);
leftPushBound= rightPushBound= selectionStart= lineEnd + 1 - Math.max(selectionStart,curPos) + lineStart;
curPos= selectionStart + delta;
}
else {
if(jumpFromPushSegment)
curPos= rightPushBound;
selectionStart= curPos= lineEnd + 1 - curPos + lineStart;
}
c_i_e_i_w_7101_setSelectedRange(obj,selectionStart,curPos);
}
c_i_e_i_w_7101_showStatusBar(obj);
}
function c_i_e_i_w_7101_processPush(obj,ieKey) {
if(((ieKey== 144) && !isLinux) || ((ieKey== 103) && isLinux)) {
preventAltNumpad= true;
if(!pushMode)
c_i_e_i_w_7101_toggleFieldOrient(obj,true,true);
}
else if(((ieKey== 111) && !isLinux) || ((ieKey== 104) && isLinux)) {
preventAltNumpad= true;
if(pushMode)
c_i_e_i_w_7101_toggleFieldOrient(obj,true,true);
}
}
function c_i_e_i_w_7101_reverse(text) {
var len= text.length;
var temp= "";
for(i= 0;i < len;i++)  {
symbol= text.charAt(len - i - 1);
symbol= c_i_e_i_w_7101_doSymSwap(symbol);
temp += symbol;
}
return temp;
}
function c_i_e_i_w_7101_reverseText(text,obj) {
var temp= "";
if(text.charAt(0)== LRO) {
temp= LRO + temp;
text= text.substring(1);
}
else if(text.charAt(0)== RLO) {
temp= RLO + temp;
text= text.substring(1);
}
textPool= text.split(CR);
temp += c_i_e_i_w_7101_reverse(textPool[0]);
for(j= 1;j < textPool.length;j++)
temp += CR + c_i_e_i_w_7101_reverse(textPool[j]);
if(isLinux && isArabic)
temp= c_i_e_i_w_7101_wfInfoDB[obj.formId].shapingEngine.ara_type(0,temp,(obj.style.direction== "rtl"));
return temp
}
function c_i_e_i_w_7101_processFieldReverse(obj,setCursor) {
if(isWrappedField)
return;
isFldreversed= !isFldreversed;
var len= obj.value.length;
if(!isIE)
curPos= obj.selectionStart;
if(len== fieldStart) {
obj.style.textAlign= (obj.style.direction== "rtl") ? "left" : "right";
setCursor= false;
}
else if((curPos== fieldStart) && (len== maxFieldLen) && (obj.value.indexOf(LF)== -1)) {
obj.style.textAlign= (obj.style.direction== "rtl") ? "left" : "right";
curPos= len - curPos + fieldStart;
}
var boundaries= c_i_e_i_w_7101_getLineBoundaries(obj);
c_i_e_i_w_7101_toggleFieldOrient(obj,false,false);
if(setCursor) {
var lineStart= boundaries[0];
var lineEnd= boundaries[1];
selectionStart= curPos= lineEnd + 1 - curPos + lineStart;
c_i_e_i_w_7101_setSelectedRange(obj,selectionStart,curPos);
}
}
function c_i_e_i_w_7101_showStatusBar(obj) {
if(!obj) return;
temp_string= "  Typing Orientation: ";
temp_string += (obj.style.direction== "rtl") ? "<=" : "=>";
temp_string += "  Autopush: ";
temp_string += (autoPush) ? "on" : "off";
temp_string += "  Push Mode: ";
temp_string += (pushMode) ? "on" : "off";
temp_string += "  Language:";
if(isArabic)
temp_string += (layerGuess) ? " A" : " E";
else
temp_string += (layerGuess) ? " H" : " E";
window.status= temp_string;
}
function c_i_e_i_w_7101_preventEraseMarker(obj) {
if(fieldStart > 0) {
if(isIE) {
if(Math.min(curPos,selectionStart) < fieldStart) {
rng= document.selection.createRange();
rng.moveStart('character', fieldStart);
rng.select();
tmp= Math.max(curPos,selectionStart);
selectionStart= fieldStart;
curPos= Math.max(tmp,selectionStart);
}
}
else {
if(obj.selectionStart < fieldStart)
obj.setSelectionRange(obj.selectionStart + 1,Math.max(fieldStart,obj.selectionEnd));
}
}
}
function c_i_e_i_w_7101_processDelete(obj) {
if(!isIE) {
selectionStart= obj.selectionStart;
curPos= obj.selectionEnd;
}
if(pushMode) {
if(selectionStart== curPos) {
if((isWrappedField && (curPos <= fieldStart)) || (curPos <= leftPushBound)) {
c_i_e_i_w_7101_preventDefault(event);
return;
}
if(isWrappedField) {
curPos--;
c_i_e_i_w_7101_setSelectedRange(obj,curPos,curPos);
}
c_i_e_i_w_7101_updatePushBounds(-1,true);
}
else
c_i_e_i_w_7101_updatePushBounds(-Math.abs(selectionStart - curPos),true);
}
c_i_e_i_w_7101_preventEraseMarker(obj);
if(isIE)
selectionStart= curPos= Math.min(selectionStart,curPos);
}
function c_i_e_i_w_7101_processBackspace(obj,event) {
if(!isIE) {
selectionStart= obj.selectionStart;
curPos= obj.selectionEnd;
}
if(curPos== selectionStart) {
if((curPos > fieldStart) || (isWrappedField && pushMode)) {
if(pushMode && (curPos== rightPushBound)) {
c_i_e_i_w_7101_preventDefault(event);
return;
}
if(pushMode) {
if(isWrappedField) {
obj.value= obj.value.substring(0,selectionStart) + obj.value.substring(curPos+1);
c_i_e_i_w_7101_setSelectedRange(obj,curPos,curPos);
c_i_e_i_w_7101_preventDefault(event);
}
c_i_e_i_w_7101_updatePushBounds(-1,true);
}
if(!pushMode || !isWrappedField)
curPos= (isIE && (obj.value.charAt(curPos - 1)== LF)) ? curPos - 2 : curPos - 1;
}
else {
c_i_e_i_w_7101_preventDefault(event);
return;
}
}
else {
if(pushMode)
c_i_e_i_w_7101_updatePushBounds(-Math.abs(selectionStart-curPos),true);
c_i_e_i_w_7101_preventEraseMarker(obj);
curPos= Math.min(selectionStart,curPos);
}
selectionStart= curPos;
}
function c_i_e_i_w_7101_processLeftarrow(obj) {
if(curPos > fieldStart) {
if (window.event.shiftKey) {//start selection
if (selectionStart== curPos)
selectionStart= curPos;
curPos= (isIE && (obj.value.charAt(curPos - 1)== LF)) ? curPos - 2 : curPos - 1;
}
else {
if(selectionStart != curPos)
selectionStart= curPos= Math.min(selectionStart,curPos);
else
selectionStart= curPos= (isIE && (obj.value.charAt(curPos - 1)== LF)) ? curPos - 2 : curPos - 1;
}
}
else
c_i_e_i_w_7101_preventDefault(event);
}
function c_i_e_i_w_7101_processRightarrow(obj) {
var text= obj.value;
if(curPos < text.length) {
if (window.event.shiftKey) {//start selection
if (selectionStart== curPos)
selectionStart= curPos;
curPos= (isIE && (obj.value.charAt(curPos + 1)== LF)) ? curPos + 2 : curPos + 1;
}
else {
if(selectionStart != curPos)
selectionStart= curPos= Math.max(selectionStart,curPos);
else
selectionStart= curPos= (isIE && (obj.value.charAt(curPos + 1)== LF)) ? curPos + 2 : curPos + 1;
}
}
else
c_i_e_i_w_7101_preventDefault(event);
}
function c_i_e_i_w_7101_updatePushBounds(delta,isForce) {
var isOverwriteMode= c_i_e_i_w_7101_isOverWriteMode();
if(isWrappedField) {
if(!isOverwriteMode || isForce)
rightPushBound += delta;
else if(curPos <= leftPushBound)
leftPushBound -= delta;
}
else if(!isOverwriteMode || (curPos== leftPushBound) || isForce)
leftPushBound += delta;
if(leftPushBound < fieldStart) leftPushBound= fieldStart+1;
if(rightPushBound < fieldStart) rightPushBound= fieldStart+1;
}
function c_i_e_i_w_7101_isOutsidePushBounds() {
return (!isWrappedField && ((curPos > leftPushBound)||(curPos < rightPushBound)) ||
isWrappedField && ((curPos < leftPushBound)||(curPos > rightPushBound)));
}
function c_i_e_i_w_7101_adjustMaxLength(obj, text) {
lamAlefs= c_i_e_i_w_7101_wfInfoDB[obj.formId].shapingEngine.getLamAlefsCountIn06Buffer(text, obj.style.direction=="rtl");
if (null != c_i_e_i_w_7101_wfInfoDB[obj.formId][obj.id].maxLength) {
obj.maxLength= c_i_e_i_w_7101_wfInfoDB[obj.formId][obj.id].maxLength;
}
if (lamAlefs > 0) {
c_i_e_i_w_7101_wfInfoDB[obj.formId][obj.id].maxLength= obj.maxLength;
obj.maxLength += lamAlefs;
maxFieldLen= obj.maxLength;
}
}
