function addConnectionOverride(paramName,paramValue,enabled)
{
	var table = document.getElementById('ConnectionOverrideTable');
	if ( table == null )	
		table = createConnectionOverrideTable();		
	
	var row = table.insertRow(table.rows.length);
	var col1 = row.insertCell(0);
	var col2 = row.insertCell(1);
	var col3 = row.insertCell(2);
	var col4 = row.insertCell(3);	
	
	if ( row.rowIndex % 2 != 0 )
		row.className = "portlet-table-alternate";
	
	col1.innerHTML = "<input type='checkbox'>";
	
	col2.innerHTML = paramName;
	col3.innerHTML = "<input class='portlet-form-input-field' type='text' size='40%' value='"+paramValue+"'>";
	if ( enabled )
		col4.innerHTML = "<select><option value='true' selected>"+True_nls+"</option><option value='false'>"+False_nls+"</option></select>";
	else
		col4.innerHTML = "<select><option value='true'>"+True_nls+"</option><option value='false' selected>"+False_nls+"</option></select>";				
		
}

function addVariableOverride(paramName,paramValue,shared,enabled)
{
	var table = document.getElementById('VariableOverrideTable');
	if ( table == null )
	{
		table = createVariableOverrideTable();	
	}	
		
	var row = table.insertRow(table.rows.length);
	var col1 = row.insertCell(0);
	var col2 = row.insertCell(1);
	var col3 = row.insertCell(2);
	var col4 = row.insertCell(3);
	var col5 = row.insertCell(4);	
	
	if ( row.rowIndex % 2 != 0 )
		row.className = "portlet-table-alternate";
	
	col1.innerHTML = "<input type='checkbox'>";
	
	col2.innerHTML = "<input class='portlet-form-input-field' type='text' size='40%' value='"+paramName+"'>";
	col3.innerHTML = "<input class='portlet-form-input-field' type='text' size='40%' value='"+paramValue+"'>";
	if ( shared )
		col4.innerHTML = "<select><option value='true' selected>"+True_nls+"</option><option value='false'>"+False_nls+"</option></select>";
	else
		col4.innerHTML = "<select><option value='true'>"+True_nls+"</option><option value='false' selected>"+False_nls+"</option></select>";
	if ( enabled )
		col5.innerHTML = "<select><option value='true' selected>"+True_nls+"</option><option value='false'>"+False_nls+"</option></select>";
	else
		col5.innerHTML = "<select><option value='true'>"+True_nls+"</option><option value='false' selected>"+False_nls+"</option></select>";				
		
}

function createConnectionOverrideTable()
{
	var tableDiv = document.getElementById('ConnectionOverrideTableArea');
	var emptyTableLabel = document.getElementById('NoConnectionOverrideLabel');
	tableDiv.removeChild(emptyTableLabel);

	var table = document.createElement('table');	
	table.id = 'ConnectionOverrideTable';
	table.width = '500';		
	var row = table.insertRow(0);	
	row.align = 'left';			
	
	var col1 = document.createElement('th');
	col1.width = '10%';
	row.appendChild(col1);
	var col2 = document.createElement('th');
	col2.width = '30%';
	col2.innerHTML = Name_nls;		
	row.appendChild(col2);
	var col3 = document.createElement('th');
	col3.width = '50%';
	col3.innerHTML = Value_nls;
	row.appendChild(col3);
	var col4 = document.createElement('th');
	col4.width = '10%';
	col4.innerHTML = Enabled_nls;
	row.appendChild(col4);
	
/*	
	var col1 = row.insertCell(0);
	col1.width = '10%';
	col1.className = 'portlet-table-header';
	var col2 = row.insertCell(1);
	col2.width = '30%';
	col2.innerHTML = 'Name';
	col2.className = 'portlet-table-header';
	var col3 = row.insertCell(2);
	col3.width = '50%';
	col3.innerHTML = 'Value';
	col3.className = 'portlet-table-header';
	var col4 = row.insertCell(3);
	col4.width = '10%';
	col4.innerHTML = 'Enabled';
	col4.className = 'portlet-table-header';	
*/
	
	tableDiv.appendChild(table);
	return table; 
}


function createVariableOverrideTable()
{
	var tableDiv = document.getElementById('VariableOverrideTableArea');
	var emptyTableLabel = document.getElementById('NoVariableOverrideLabel');
	tableDiv.removeChild(emptyTableLabel);

	var table = document.createElement('table');
	table.id = 'VariableOverrideTable';
	table.width = '500';		
	var row = table.insertRow(0);	
	row.align = 'left';			
	
	var col1 = document.createElement('th');
	col1.width = '10%';
	row.appendChild(col1);
	var col2 = document.createElement('th');
	col2.width = '30%';
	col2.innerHTML = Name_nls;
	row.appendChild(col2);
	var col3 = document.createElement('th');
	col3.width = '40%';
	col3.innerHTML = Value_nls;
	row.appendChild(col3);	
	var col4 = document.createElement('th');
	col4.width = '10%';
	col4.innerHTML = Shared_nls;
	row.appendChild(col4);
	var col5 = document.createElement('th');
	col5.width = '10%';
	col5.innerHTML = Enabled_nls;
	row.appendChild(col5);
	tableDiv.appendChild(table);
	return table; 
}	

function deleteSelectedRows(tableName)
{
	var table = document.getElementById(tableName);	
	var deletingRows = new Array();
	var num = 0;
	
	for ( i = 1; i < table.rows.length; i++ )
	{		
		var row = table.rows[i];
		var col1 = row.cells[0];
		var checkbox = col1.firstChild;		
		if ( checkbox != null && checkbox.checked )
		{
			deletingRows[num] = row;
			num++;
		}
	}
	
	if ( num > 0 )
	{
		for ( j = 0; j < deletingRows.length; j++ )
		{
			table.deleteRow(deletingRows[j].rowIndex);
		}
	}
}

function saveOverrides()
{	
	var coTable = document.getElementById('ConnectionOverrideTable');
	var voTable = document.getElementById('VariableOverrideTable');	
	if ( coTable == null && voTable == null )
	{
		var editActionInput = document.getElementById('editAction');	
		editActionInput.value = "cancel";
	}
	else
	{
		if ( coTable != null )
		{		
			var coBuffer = "";	
			for ( i = 1; i< coTable.rows.length; i++ )
			{
				var row = coTable.rows[i];				
				var paramName = row.cells[1].innerHTML;
				var paramValue = row.cells[2].firstChild.value;
				var enabled = true;
				if ( row.cells[3].firstChild.selectedIndex == 1 )
					enabled = false;
				coBuffer += paramName + ',' + paramValue + ',' + enabled + ';';			
			}				
			var connectionOverrideParams = document.getElementById('connectionOverrideParams');	
			connectionOverrideParams.value = coBuffer;
		}
		
		if ( voTable != null )
		{
			var voBuffer = "";
			for ( i = 1; i < voTable.rows.length; i++ )
			{
				var row = voTable.rows[i];
				var name = row.cells[1].firstChild.value;
				var value = row.cells[2].firstChild.value;
				var shared = true;
				if ( row.cells[3].firstChild.selectedIndex == 1 )
					shared = false;
				var enabled = true;	
				if ( row.cells[4].firstChild.selectedIndex == 1 )	
					enabled = false;
				voBuffer += name + ',' + value + ',' + shared + ',' + enabled + ';';	
			}
			var variableOverrideParams = document.getElementById('variableOverrideParams');
			variableOverrideParams.value = voBuffer;			
		}	
		
		var editActionInput = document.getElementById('editAction');;
		editActionInput.value = "save";
	}
	var form = document.getElementById('EditForm');	
	form.submit();			
}

function clearText(fieldId)
{
	var textfield = document.getElementById(fieldId);
	if ( textfield != null )
		textfield.value = "";
}

