%if $hasPackage$
package $package$;
%endif

import org.eclipse.swt.*;
import org.eclipse.swt.graphics.*;
import org.eclipse.swt.layout.*;
import org.eclipse.swt.widgets.*;

import com.ibm.hats.rcp.transform.*;
import com.ibm.hats.rcp.ui.templates.*;

%if $hasClassDescription$
/*
$classDescription$
*/

%endif
public class $classname$ extends RcpTemplate {

    protected TransformationAreaComposite transformationArea;

    /**
     * @param parent
     * @param style
     */
    public $classname$(Composite parent, int style) {
        super(parent, style);
 
        initialize();
    }

    /**
     * 
     */
    private void initialize() {
        GridLayout layout = new GridLayout(1, false);
        setLayout(layout);
        setLayoutData(new GridData(GridData.FILL_BOTH));
        
        if (java.beans.Beans.isDesignTime()) {
            this.setSize(new Point(400, 250));
        }
        
        createTransformationArea();        
    }

    /**
     * 
     */
    private void createTransformationArea() {
        transformationArea = new TransformationAreaComposite(this, SWT.NONE);
        GridLayout layout = new GridLayout(1, false);
        layout.marginWidth = 0;
        layout.marginHeight = 0;
        transformationArea.setLayout(layout);
        transformationArea.setLayoutData(new GridData(GridData.FILL_BOTH));        
    }

    /* (non-Javadoc)
     * @see com.ibm.hats.rcp.ui.templates.RcpTemplate#getTransformationArea()
     */
    public Composite getContentContainer() {
        return transformationArea;
    }

    /* (non-Javadoc)
     * @see com.ibm.hats.rcp.ui.templates.RcpTemplate#getDefaultFont()
     */
    public Font getDefaultFont() {
        return super.getDefaultFont();
    }
    
    /* (non-Javadoc)
     * @see com.ibm.hats.rcp.ui.templates.RcpTemplate#getDefaultBackgroundColor()
     */
    public Color getDefaultBackgroundColor() {
        return (Display.getCurrent().getSystemColor(SWT.COLOR_WIDGET_BACKGROUND));
    }

    /* (non-Javadoc)
     * @see com.ibm.hats.rcp.ui.templates.RcpTemplate#getDefaultForegroundColor()
     */
    public Color getDefaultForegroundColor() {
        return (Display.getCurrent().getSystemColor(SWT.COLOR_WIDGET_FOREGROUND));
    }
    
    /* (non-Javadoc)
     * @see com.ibm.hats.rcp.ui.templates.RcpTemplate#getColorMapper()
     */
    public IColorMapper getColorMapper() {
        return WhiteBackgroundColorMapper.getInstance();
    }
}
    