//
// Module Name     : BeanInfoMessages.java
//
// IBM Confidential
//
// OCO Source Materials 
//
// 5724-L02
//
//  Copyright IBM Corp. 2007.  All Rights Reserved.
//
// The source code for this program is not published or otherwise divested 
// of its trade secrets, irrespective of what has been deposited with the
// U.S. Copyright Office.
//
// Product: IBM WebSphere HATS
//
// Component: HATS STUDIO
//
// Author: Tami Takamiya (ttakamiy@us.ibm.com)
//
// ---------------------------------------------------------------------------
// Function: Beaninfo Messages
//
// ---------------------------------------------------------------------------
// Related:
//
// ---------------------------------------------------------------------------
// Change Activity
//
// --------------------------------------------------------------------------
//  Flag  Reason   Who  Date       Description of changes
//  ----  -------- ---- ---------- -------------------------------------------
//        34323    Tami 26Sep2006  Newly created
//
package com.ibm.hats.rcp.transform.beaninfo;

import java.util.MissingResourceException;
import java.util.ResourceBundle;

public class BeanInfoMessages {

    /** The HATSCopyright.COPYRIGHT field will be updated each release, thereby "magically" updating this class file. */
    private static final String COPYRIGHT = com.ibm.hats.util.HatsCopyright.COPYRIGHT;

	private static final String BUNDLE_NAME = "com.ibm.hats.rcp.transform.beaninfo.beaninfo";//$NON-NLS-1$

	private static final ResourceBundle RESOURCE_BUNDLE = ResourceBundle.getBundle(BUNDLE_NAME);

	private BeanInfoMessages() {
	}

	public static String getString(String key) {
		try {
			return RESOURCE_BUNDLE.getString(key);
		} catch (MissingResourceException e) {
			return '!' + key + '!';
		}
	}
}