//
// Module Name     : ComponentRenderingBeanInfo.java
//
// IBM Confidential
//
// OCO Source Materials 
//
// 5724-U67 5724-U68 5724-L02
//
//  Copyright IBM Corp. 2007, 2008  All Rights Reserved.
//
// The source code for this program is not published or otherwise divested 
// of its trade secrets, irrespective of what has been deposited with the
// U.S. Copyright Office.
//
// Product: IBM WebSphere HATS
//
// Component: HATS STUDIO
//
// Author: Tami Takamiya (ttakamiy@us.ibm.com)
//
// ---------------------------------------------------------------------------
// Function: Beaninfo for AbstractKeyComposite
//
// ---------------------------------------------------------------------------
// Related:
//
// ---------------------------------------------------------------------------
// Change Activity
//
// --------------------------------------------------------------------------
//  Flag  Reason   Who  Date       Description of changes
//  ----  -------- ---- ---------- -------------------------------------------
//        34323    Tami 26Sep2006  Moved from com.ibm.hats.rcp.ui
//  $d01  36203    Tami 16Jan2006  Add alternate and alternateRenderingSet
//  $bd1            MKH 7Oct2007   Add Bidi CheckBox to widget Advanced 
//                                 settings for Rendering dialog
//
package com.ibm.hats.rcp.transform.beaninfo;

import java.beans.BeanDescriptor;
import java.beans.BeanInfo;
import java.beans.IntrospectionException;
import java.beans.Introspector;
import java.beans.PropertyDescriptor;

import org.eclipse.swt.widgets.Control;
import org.eclipse.swt.widgets.beaninfo.IvjBeanInfo;
import org.eclipse.swt.widgets.beaninfo.SweetHelper;

import com.ibm.hats.rcp.transform.AbstractRenderingComposite;
import com.ibm.hats.rcp.transform.ComponentRendering;

//public class ComponentRenderingBeanInfo extends SimpleBeanInfo
public class ComponentRenderingBeanInfo extends IvjBeanInfo
{
    /** The HATSCopyright.COPYRIGHT field will be updated each release, thereby "magically" updating this class file. */
    private static final String COPYRIGHT = com.ibm.hats.util.HatsCopyright.COPYRIGHT;

    public Class getBeanClass() {
        return com.ibm.hats.rcp.transform.ComponentRendering.class;
    }

    public BeanInfo[] getAdditionalBeanInfo()
	{		
		try
		{
			return new BeanInfo[] {Introspector.getBeanInfo(Control.class)};			
		}
		catch ( IntrospectionException e )
		{
			return new BeanInfo[0];
		}
	}
    
    public BeanDescriptor getBeanDescriptor() {
        BeanDescriptor descriptor = new BeanDescriptor(getBeanClass());
        SweetHelper.mergeSuperclassStyleBits(descriptor);
        return descriptor;
    }


	public PropertyDescriptor[] getPropertyDescriptors()
	{		
	    try
	    {
            //@d01c start
	    	return new PropertyDescriptor[] {
                    new PropertyDescriptor("component",ComponentRendering.class),
	    	        new PropertyDescriptor("widget",ComponentRendering.class),
	    	        new PropertyDescriptor("region",ComponentRendering.class),
	    	        new PropertyDescriptor("screenCapture",AbstractRenderingComposite.class),
	    	        new PropertyDescriptor("componentSettings",ComponentRendering.class),
	    	        new PropertyDescriptor("widgetSettings",ComponentRendering.class),
	    	        new PropertyDescriptor("applyTextReplacement",ComponentRendering.class),
	    	        new PropertyDescriptor("applyGlobalRules",ComponentRendering.class),
	    	        new PropertyDescriptor("textReplacementList",ComponentRendering.class),
                    new PropertyDescriptor("alternate", ComponentRendering.class),
                    new PropertyDescriptor("alternateRenderingSet", ComponentRendering.class),
                    new PropertyDescriptor("BIDIOpposite", ComponentRendering.class),//@bd1a
                    };
            //@d01c end
	    }
	    catch ( Exception e )
	    {
	    	return null;
	    }
	}

	
}
