//
// Module Name     : DefaultRenderingBeanInfo.java
//
// IBM Confidential
//
// OCO Source Materials 
//
// 5724-L02
//
//  Copyright IBM Corp. 2007.  All Rights Reserved.
//
// The source code for this program is not published or otherwise divested 
// of its trade secrets, irrespective of what has been deposited with the
// U.S. Copyright Office.
//
// Product: IBM WebSphere HATS
//
// Component: HATS STUDIO
//
// Author: Tami Takamiya (ttakamiy@us.ibm.com)
//
// ---------------------------------------------------------------------------
// Function: Beaninfo for AbstractKeyComposite
//
// ---------------------------------------------------------------------------
// Related:
//
// ---------------------------------------------------------------------------
// Change Activity
//
// --------------------------------------------------------------------------
//  Flag  Reason   Who  Date       Description of changes
//  ----  -------- ---- ---------- -------------------------------------------
//        34323    Tami 26Sep2006  Moved from com.ibm.hats.rcp.ui
//
package com.ibm.hats.rcp.transform.beaninfo;

import java.beans.BeanDescriptor;
import java.beans.BeanInfo;
import java.beans.IntrospectionException;
import java.beans.Introspector;
import java.beans.PropertyDescriptor;

import org.eclipse.swt.widgets.Control;
import org.eclipse.swt.widgets.beaninfo.IvjBeanInfo;
import org.eclipse.swt.widgets.beaninfo.SweetHelper;

import com.ibm.hats.rcp.transform.AbstractRenderingComposite;
import com.ibm.hats.rcp.transform.DefaultRendering;

//public class DefaultRenderingBeanInfo extends SimpleBeanInfo
public class DefaultRenderingBeanInfo extends IvjBeanInfo
{
    /** The HATSCopyright.COPYRIGHT field will be updated each release, thereby "magically" updating this class file. */
    private static final String COPYRIGHT = com.ibm.hats.util.HatsCopyright.COPYRIGHT;

    public Class getBeanClass() {
        return com.ibm.hats.rcp.transform.DefaultRendering.class;
    }

	public BeanInfo[] getAdditionalBeanInfo()
	{		
		try
		{
			return new BeanInfo[] {Introspector.getBeanInfo(Control.class)};			
		}
		catch ( IntrospectionException e )
		{
			return new BeanInfo[0];
		}
	}

    public BeanDescriptor getBeanDescriptor() {
        BeanDescriptor descriptor = new BeanDescriptor(getBeanClass());
        SweetHelper.mergeSuperclassStyleBits(descriptor);
        return descriptor;
    }


	public PropertyDescriptor[] getPropertyDescriptors()
	{		
	    try
	    {
	      PropertyDescriptor[] result = new PropertyDescriptor[5];

	      result[0] = new PropertyDescriptor("region",DefaultRendering.class);
	      result[1] = new PropertyDescriptor("transformationClassname",AbstractRenderingComposite.class);
	      result[2] = new PropertyDescriptor("applyTextReplacement",DefaultRendering.class);
	      result[3] = new PropertyDescriptor("applyGlobalRules",DefaultRendering.class);
	      result[4] = new PropertyDescriptor("renderingSetName",DefaultRendering.class);
	      
	      
	      return result;
	    }
	    catch ( Exception e )
	    {
	    	return null;
	    }
	}

	
}
