//
// Module Name     : AbstractKeyCompositeBeanInfo.java
//
// IBM Confidential
//
// OCO Source Materials 
//
// 5724-L02
//
//  Copyright IBM Corp. 2007.  All Rights Reserved.
//
// The source code for this program is not published or otherwise divested 
// of its trade secrets, irrespective of what has been deposited with the
// U.S. Copyright Office.
//
// Product: IBM WebSphere HATS
//
// Component: HATS STUDIO
//
// Author: Tami Takamiya (ttakamiy@us.ibm.com)
//
// ---------------------------------------------------------------------------
// Function: Beaninfo for AbstractKeyComposite
//
// ---------------------------------------------------------------------------
// Related:
//
// ---------------------------------------------------------------------------
// Change Activity
//
// --------------------------------------------------------------------------
//  Flag  Reason   Who  Date       Description of changes
//  ----  -------- ---- ---------- -------------------------------------------
//        34323    Tami 26Sep2006  Newly created
//
package com.ibm.hats.rcp.transform.beaninfo;

import java.beans.BeanDescriptor;
import java.beans.PropertyDescriptor;

import org.eclipse.swt.widgets.beaninfo.IvjBeanInfo;
import org.eclipse.swt.widgets.beaninfo.SweetHelper;

import com.ibm.hats.rcp.transform.SwtTransformationConstants;
//import com.ibm.hats.studio.HatsPlugin;

public class GlobalVariableControlBeanInfo extends IvjBeanInfo {

    /** The HATSCopyright.COPYRIGHT field will be updated each release, thereby "magically" updating this class file. */
    private static final String COPYRIGHT = com.ibm.hats.util.HatsCopyright.COPYRIGHT;

    private static final String STYLE= "style";
    
    public Class getBeanClass() {
        return com.ibm.hats.rcp.transform.GlobalVariableControl.class;
    }

    public BeanDescriptor getBeanDescriptor() {
        BeanDescriptor descriptor = new BeanDescriptor(getBeanClass());
        descriptor.setValue(SweetHelper.STYLE_BITS_ID, new Object[][] { {
                STYLE,
                STYLE,
                Boolean.FALSE,
                new Object[] { 
                        BeanInfoMessages.getString("LABEL"), "com.ibm.hats.rcp.transform.SwtTransformationConstants.LABEL", new Integer(SwtTransformationConstants.LABEL), //TODO NLS 
                        BeanInfoMessages.getString("TEXT"), "com.ibm.hats.rcp.transform.SwtTransformationConstants.TEXT", new Integer(SwtTransformationConstants.TEXT)   //TODO NLS
                        } 
                } 
        } );
        SweetHelper.mergeSuperclassStyleBits(descriptor);
        return descriptor;
    }

    public PropertyDescriptor[] getPropertyDescriptors() {
        return null;
    }
}
